<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access
defined('_JEXEC') or die('Restricted access');

// through the variable $pdf you can access the current TCPDF instance and change almost everything (fonts, page breaking, margins, etc.)
// see: http://www.tcpdf.org/docs.php
?>

<style type="text/css">
    .page{
        font-size: 8pt;
    }
    
    .positions th{
        height: 25mm !important;
        font-weight: bold !important;
        font-size: 10pt !important;
    }
    
    .positions td, .positions th{
       border: 1px solid #cccccc;
       padding: 1mm;
       text-align: left;
    }
    
    .positions{
        width: 100%;
        border: 1px solid #cccccc;
        border-bottom: 3px solid #cccccc;
    }
</style>

<div class="page">
    
    <table style="width:100%;height:99mm;">
        
        <tr>
            <td style="width:65%;">
                
                <table style="width:100%;">
                    
                    <tr>
                        <td style="height: 30mm;">
                            <?php if($logo):?>
                            <img src="<?php echo $logo; ?>" width="<?php echo $logo_info[0]?>" height="<?php echo $logo_info[1]?>"/>
                            <?php else :?>
                            &nbsp;
                            <?php endif; ?>
                        </td>
                    </tr>
                    
                    <tr>
                        <td style="font-size: 10pt;">
                            <span style="font-size: 6pt;"><?php echo $config->get('business_name','');?> | <?php echo $config->get('business_address','');?> <?php echo $config->get('business_address2','');?> | <?php echo $config->get('business_zip','');?> <?php echo $config->get('business_city','');?> | <?php echo $config->get('business_country','');?> <?php echo $config->get('business_region','') ? ' / ' . $config->get('business_region','') : '' ;?></span>
                            
                            <br />
                            <br />
                            
                            <?php
                            if( $customer->company != '' ){
                            ?>
                            
                            <?php echo $customer->company;?>
                            
                            <br />
                            <?php
                            }
                            ?>
                            
                            <?php echo $customer->firstname;?> <?php echo $customer->lastname;?>
                            
                            <br />
                            
                            <?php echo $customer->address;?> <?php echo $customer->address2;?>
                            
                            <br />
                            
                            <?php echo $customer->zip;?> <?php echo $customer->city;?>
                            
                            <br />
                            
                            <?php echo $customer->country;?> <?php echo $customer->region ? ' / ' . $customer->region : '';?>
                            
                        </td>
                    </tr>
                    
                </table>
                
            </td>
            <td style="width:35%;text-align: left;">
                
                <h3><?php echo $config->get('business_name','');?></h3>
                
                <br />
                
                <?php echo $config->get('business_address','');?> <?php echo $config->get('business_address2','');?>
                
                <br />
                
                <?php echo $config->get('business_zip','');?> <?php echo $config->get('business_city','');?>
                
                <br />
                
                <?php echo $config->get('business_country','');?> <?php echo $config->get('business_region','') ? ' / ' . $config->get('business_region','') : '' ;?>
                
                <br />
                
                <?php if($config->get('business_phone','')):?>
                
                <br />
                
                <?php echo JText::_('COM_BREEZINGCOMMERCE_PHONE'); ?>: <?php echo $config->get('business_phone','');?>
                
                <br />
                
                <?php endif; ?>
                
                <?php if($config->get('business_mobile','')):?>
                
                <?php echo JText::_('COM_BREEZINGCOMMERCE_MOBILE'); ?>: <?php echo $config->get('business_mobile','');?>
                
                <br />
                
                <?php endif; ?>
                
                <?php if($config->get('business_fax','')):?>
                
                <?php echo JText::_('COM_BREEZINGCOMMERCE_FAX'); ?>: <?php echo $config->get('business_fax','');?>
                
                <br />
                
                <?php endif; ?>
                
                <br />
                
                <?php if($config->get('business_web','')):?>
                
                <?php echo JText::_('COM_BREEZINGCOMMERCE_WEB'); ?>: <?php echo $config->get('business_web','');?>
                
                <br />
                
                <?php endif; ?>
                
                <?php if($config->get('business_email','')):?>
                
                <?php echo JText::_('COM_BREEZINGCOMMERCE_EMAIL'); ?>: <?php echo $config->get('business_email','');?>
                
                <br />
                
                <?php endif; ?>
                
                <?php if($config->get('business_free_text_html','')):?>
                
                <br />
                
                <?php echo $config->get('business_free_text_html','');?>
                
                <br />
                
                <?php endif; ?>
                
            </td>
        </tr>
        
    </table>
    
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>

    <table width="100%">

        <tr>
            <td style="width:65%;white-space: nowrap;"><?php echo JText::_('COM_BREEZINGCOMMERCE_CUSTOMER_NUMBER');?>: <span style="font-size: 10pt;"><?php echo $customer->id;?></span> | <?php echo JText::_('COM_BREEZINGCOMMERCE_ORDER_NUMBER');?>: <span style="font-size: 10pt;"><?php echo $order->order_number;?></span></td>
            <td style="width:35%;text-align: right;"><?php echo JText::_('COM_BREEZINGCOMMERCE_DATE');?>: <span style="font-size: 10pt;"><?php echo JHTML::_('date', $order_info->invoice_date, JText::_('DATE_FORMAT_LC1'))?></span></td>
        </tr>

    </table>

    <br/>
    <br/>
  
    <strong style="font-size: 10pt;"><?php echo JText::_('COM_BREEZINGCOMMERCE_CANCELLATION_NUMBER');?></strong>&nbsp;&nbsp;<span style="font-size: 10pt;"><?php echo $invoice_number;?></span>
    
    <br/>
    <br/>
    
    <?php 
    $amt_cols = 0;
    if($config->get('cart_display_unit_net_column', 1) == 1){
        $amt_cols++;
    }
    if($config->get('cart_display_total_net_column', 1) == 1){
        $amt_cols++;
    }
    if($config->get('cart_display_unit_gross_column', 1) == 1){
        $amt_cols++;
    }
    if($config->get('cart_display_total_gross_column', 1) == 1){
        $amt_cols++;
    }
    if($config->get('cart_display_unit_tax_column', 1) == 1){
        $amt_cols++;
    }
    if($config->get('cart_display_total_tax_column', 1) == 1){
        $amt_cols++;
    }
    
    $ratio = 60;
    
    if($amt_cols != 0){
        $ratio = (60 / $amt_cols);
    }
    ?>
    
    <table class="positions" cellspacing="0" cellpadding="5">

        <thead>
            <tr>
                <th style="width: <?php if($amt_cols == 1){ echo '60'; } else { echo '30'; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT')?></strong></th>

                <th style="width: 10%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_QUANTITY')?></strong></th>

                <?php if($config->get('cart_display_unit_net_column', 1) == 1): ?>
                <th style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_UNIT_PRICE_NET')?></strong></th>
                <?php endif;?>

                <?php if($config->get('cart_display_total_net_column', 1) == 1): ?>
                <th style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL_PRICE_NET')?></strong></th>
                <?php endif;?>
                
                <?php if($config->get('cart_display_unit_tax_column', 1) == 1): ?>
                <th style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_UNIT_TAX')?></strong></th>
                <?php endif;?>

                <?php if($config->get('cart_display_unit_gross_column', 1) == 1): ?>
                <th style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_UNIT_PRICE')?></strong></th>
                <?php endif;?>
                
                <?php if($config->get('cart_display_total_tax_column', 1) == 1): ?>
                <th style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL_TAX')?></strong></th>
                <?php endif;?>
                
                <?php if($config->get('cart_display_total_gross_column', 1) == 1): ?>
                <th style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%;text-align: center;vertical-align: middle;"><strong><?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL_PRICE')?></strong></th>
                <?php endif;?>

                
            </tr>
        </thead>

        <tbody>

            <?php foreach($items As $item):?>

            <tr>
                <td style="width:<?php if($amt_cols == 1){ echo '60'; } else { echo '30'; } ?>%;"><h4><?php echo $item->title?></h4><?php echo $item->properties ? '<br/><br/>' . trim($item->properties) : ''?><?php echo $item->attributes_invoice?>
                    <?php 
                    foreach( $item->order_item_info As $order_item_info ){
                    ?>
                    <div>
                        <h4><?php echo $order_item_info->title; ?></h4>
                        <?php 
                        echo $order_item_info->text;
                        ?>
                    </div>
                    <?php
                    }
                    ?>
                </td>
                
                <td style="width: 10%; text-align: center;"><?php echo $item->amount; ?></td>

                <?php if($config->get('cart_display_unit_net_column', 1) == 1): ?>
                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($item->price_single_net)?></td>
                <?php endif;?>

                <?php if($config->get('cart_display_total_net_column', 1) == 1): ?>
                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($item->price_net)?></td>
                <?php endif;?>
                
                <?php if($config->get('cart_display_unit_tax_column', 1) == 1): ?>
                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php
                $tax_list = $item->single_price_tax_list;
                foreach($tax_list As $tax){
                ?><?php echo $_cart_instance->formatPrice($tax['tax']) . '<br />'. "\n" . $tax['name'] . ' ('.CrBcCart::formatNumber($tax['rate']).'%)<br /><br />'. "\n";?><?php
                }
                ?></td><?php endif;?>

                <?php if($config->get('cart_display_unit_gross_column', 1) == 1): ?>
                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($item->price_single_gross)?></td>
                <?php endif;?>

                <?php if($config->get('cart_display_total_tax_column', 1) == 1): ?>
                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php
                $tax_list = $item->price_tax_list;
                foreach($tax_list As $tax){
                ?><?php echo $_cart_instance->formatPrice($tax['tax']) . '<br />'. "\n" . $tax['name'] . ' ('.CrBcCart::formatNumber($tax['rate']).'%)<br /><br />'. "\n";?><?php
                }
                ?></td><?php endif;?>
                
                <?php if($config->get('cart_display_total_gross_column', 1) == 1): ?>
                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($item->price_gross)?></td>
                <?php endif;?>

            </tr>

            <?php endforeach; ?>

        </tbody>
    </table>

    <table style="border: none;border-bottom:none;" class="positions" cellspacing="0" cellpadding="5">

        <?php if($config->get('cart_display_tax_position', 'below_calculation') == 'in_calculation'): ?>

            <tr>

                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>
                
                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center;"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_SUBTOTAL_NET' ); ?></td>

                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($order_info->price_net)?></td>

            </tr>

            <?php foreach($order_info->price_tax_list As $key => $info):?>

            <tr>

                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>
                
                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center;"><?php echo $info['name']?> (<?php echo CrBcCart::formatNumber($info['rate'])?>%)</td>

                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($info['tax'])?></td>

            </tr>
            <?php endforeach; ?>

            <?php endif; ?>
            
            <?php if($config->get('cart_display_subtotal_gross_column', 1) == 1): ?>
            
            <tr>

                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>
                
                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center;"><?php echo JText::_('COM_BREEZINGCOMMERCE_SUBTOTAL')?></td>

                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($order_info->price_gross)?></td>

            </tr>
            
            <?php endif; ?>
            
            <tr>

                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>
                
                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border-bottom: 3px solid #cccccc;"><?php echo JText::_('COM_BREEZINGCOMMERCE_SHIPPING_COSTS')?></td>

                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center; border-bottom: 3px solid #cccccc;"><?php echo $_cart_instance->formatPrice($order_info->shipping_costs)?></td>

            </tr>
            
            <tr>

                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>
                
                <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border-bottom: 3px solid #cccccc;"><h3><?php echo JText::_('COM_BREEZINGCOMMERCE_REFUND_TOTAL')?></h3></td>

                <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center; border-bottom: 3px solid #cccccc;"><h3><?php echo $_cart_instance->formatPrice($order_info->grand_total)?></h3></td>

            </tr>
            
            <!-- Taxes if position below -->
            <?php if(count($order_info->price_tax_list) && $config->get('cart_display_tax_position', 'below_calculation') == 'below_calculation'): ?>
                
                <tr>
                    <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>

                    <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center;"><?php echo JText::_('COM_BREEZINGCOMMERCE_INCLUDED_TAXES'); ?></td>

                    <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php foreach($order_info->price_tax_list As $key => $info):?><?php echo $info['name']?> (<?php echo CrBcCart::formatNumber($info['rate'])?>%)<br/><?php echo $_cart_instance->formatPrice($info['tax'])?><br/><br/><?php endforeach; ?></td>

                </tr>
                    
                <!-- Subtotal -->
                <?php if($config->get('cart_display_subtotal_net_column', 1) == 1): ?>
                
                    <tr>

                        <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center; border: none;">&nbsp;</td>

                        <td style="width: <?php echo $amt_cols == 1 ? (100-30)/2 : ((100-$ratio)/2);?>%; text-align: center;"><?php echo JText::_('COM_BREEZINGCOMMERCE_SUBTOTAL_NET')?></td>

                        <td style="width: <?php if($amt_cols == 1){ echo '30'; } else { echo $ratio; } ?>%; text-align: center;"><?php echo $_cart_instance->formatPrice($order_info->price_net)?></td>

                    </tr>
                
                <?php endif; ?>
                
            <?php endif; ?>
         
                
                
    </table>
    
    <?php
    if(count($logs)){
    ?>
    
    <table width="100%">
        <?php
        foreach($logs As $log){
        ?>
        <tr>
            <td><?php echo $log->message; ?></td>
        </tr>
        <?php
        }
        ?>
    </table>
    
    <br/>
    <br/>
    
    <?php
    }
    ?>

</div>