<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.helper' );

if (!JFactory::getUser()->authorise('core.manage', 'com_breezingcommerce')) 
{
    throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
}

if(!defined('DS')){
    define('DS','/');
}

JHtml::_('behavior.keepalive');

require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'CrBcCartException.php');
require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'CrBcOutOfStockException.php');
require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'CrBcAttributesOutOfStockException.php');
require_once(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php');
CrBcHelpers::addCssFile(Juri::root(true).'/components/com_breezingcommerce/css/font-awesome/css/font-awesome.min.css');
        
JHtml::_('bootstrap.tooltip');

JHtml::_('behavior.framework', true);
// force jquery to be loaded after mootools but before any other js (since J! 3.4)
JHtml::_('jquery.framework');

if(count(JLanguageHelper::getLanguages()) > 1){

    $toolbar = JToolbar::getInstance('toolbar');
    $toolbar->addButtonPath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.'/buttons');
    $toolbar->appendButton('Crbclanguages');
    $toolbar->appendButton('Crbcdivider');
}

JFactory::getDocument()->addScript(JURI::root(true).'/components/com_breezingcommerce/js/breezingcommerce.js');
// JFactory::getDocument()->addStyleSheet(JURI::root(true).'/administrator/components/com_breezingcommerce/assets/css/breezingcommerce.css');
CrBcHelpers::addCssFile(JUri::root(true).'/administrator/components/com_breezingcommerce/assets/css/breezingcommerce.css');
jimport('joomla.version');
$version = new JVersion();

define('CRBCOLDJ', false);

// adding submenu items

$edit_task = JRequest::getVar('task','') == 'edit';
$is_new    = JRequest::getVar('task','') == 'add';

//if(!$edit_task && !$is_new){
if(true){
    JSubMenuHelper::addEntry(
                        JText::_('<a href="https://crosstec.org"><img src="../administrator/components/com_breezingcommerce/assets/images/logo.png" border="0" alt="logo"></a>'));
    JSubMenuHelper::addEntry('<i class="icon-dashboard iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_DASHBOARD'),
                        'index.php?option=com_breezingcommerce', JRequest::getVar('controller','') == '' );
    JSubMenuHelper::addEntry('<i class="icon-file-2 iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_ORDERS'),
                        'index.php?option=com_breezingcommerce&controller=orders', JRequest::getVar('controller','') == 'orders' );
    JSubMenuHelper::addEntry('<i class="icon-basket iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_PRODUCTS'),
                        'index.php?option=com_breezingcommerce&controller=products', JRequest::getVar('controller','') == 'products' );
    JSubMenuHelper::addEntry('<i class="icon-list-2 iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_CATEGORIES'),
                        'index.php?option=com_breezingcommerce&controller=categories', JRequest::getVar('controller','') == 'categories' );
    JSubMenuHelper::addEntry('<i class="icon-users iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_CUSTOMERS'),
                        'index.php?option=com_breezingcommerce&controller=customers', JRequest::getVar('controller','') == 'customers' );
    JSubMenuHelper::addEntry('<i class="icon-apply iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_PROPERTIES'),
                        'index.php?option=com_breezingcommerce&controller=properties', JRequest::getVar('controller','') == 'properties' );
    JSubMenuHelper::addEntry('<i class="icon-file-add iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_ATTRIBUTES'),
                        'index.php?option=com_breezingcommerce&controller=attributes', JRequest::getVar('controller','') == 'attributes' );
    JSubMenuHelper::addEntry('<i class="icon-tags iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_MANUFACTURERS'),
                        'index.php?option=com_breezingcommerce&controller=manufacturers', JRequest::getVar('controller','') == 'manufacturers' );
    JSubMenuHelper::addEntry('<i class="icon-loop iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_CURRENCIES'),
                        'index.php?option=com_breezingcommerce&controller=currencies', JRequest::getVar('controller','') == 'currencies' );
    JSubMenuHelper::addEntry('<i class="icon-location iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_COUNTRIES'),
                        'index.php?option=com_breezingcommerce&controller=countries', JRequest::getVar('controller','') == 'countries' );
    JSubMenuHelper::addEntry('<i class="icon-credit iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_TAXES'),
                        'index.php?option=com_breezingcommerce&controller=taxes', JRequest::getVar('controller','') == 'taxes' );
    JSubMenuHelper::addEntry('<i class="icon-puzzle iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_PLUGINS'),
                        'index.php?option=com_breezingcommerce&controller=plugins', JRequest::getVar('controller','') == 'plugins' );
    JSubMenuHelper::addEntry('<i class="icon-options iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_CONFIGURATION'),
                        'index.php?option=com_breezingcommerce&controller=configuration', JRequest::getVar('controller','') == 'configuration' );
    JSubMenuHelper::addEntry('<i class="icon-help iconGap"></i>' .
                        JText::_('COM_BREEZINGCOMMERCE_DOCS'),
                        'https://crosstec.org/en/support/online-documentation/breezingcommerce-documentation.html' );
   

}

// Require the base controller
require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'CrBcHelpers.php');
$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcPlugin.php');
require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'controller.php' );

// Require specific controller if requested
$controller = JRequest::getWord('controller');
if($controller) {
    $path = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'controllers'.DS.$controller.'.php';
    if (file_exists($path)) {
        require_once $path;
    } else {
        $controller = '';
    }
}

// Create the controller
$classname    = 'BreezingcommerceController'.ucfirst( $controller );
$controller   = new $classname( );

// Perform the Request task
$controller->execute( JRequest::getWord( 'task' ) );

// Redirect if set by the controller
$controller->redirect();
