<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

class CrBcPriceMap{
    
    function __construct() {
        
    }
    
    function generateForCurrencies(){
        
        $db = JFactory::getDbo();
        
        if( JRequest::getInt('gen_product_idx', -1) > -1 ){
            
            $db->setQuery("Select SQL_CACHE SQL_CALC_FOUND_ROWS id, producttaxclass_id From #__breezingcommerce_products", JRequest::getInt('gen_product_idx', 0), 50);
                
            $products = $db->loadObjectList();

            $db->setQuery('SELECT FOUND_ROWS();');
            $total = $db->loadResult();
            
            if( count($products) == 0 ){
                
                JFactory::getApplication()->enqueueMessage(JText::_('COM_BREEZINGCOMMERCE_REGEN_SUCCESS_MSG'));
                
                return '
                    <script>
                    jQuery(document).ready(function(){
                        location.href = '.  CrBcHelpers::jsonEncode(CrBcHelpers::bSixtyFourDecode(JRequest::getVar('orig_url',''))) . ';
                    });
                    </script>
                ';
            }
            
            foreach( $products As $product ){

                CrBcHelpers::addToCurrencyPriceMap($product->id, $product->producttaxclass_id);
            }
            
            @ob_end_clean();
            ob_start();
            
            echo '
                
            <div id="crbc-reload-currency-progress">
                <div class="crbc-progress progress">
                    <div class="crbc-bar bar" style="width: '.((JRequest::getInt('gen_product_idx', 0)/$total) * 100).'%;"></div>
                </div>
                
            </div>
           <script type="text/javascript">
                jQuery(document).ready(function(){
                    
                    var current_url = '.  CrBcHelpers::jsonEncode(CrBcHelpers::bSixtyFourDecode(JRequest::getVar('orig_url',''))) . ';
                    var orig_url    = "'.  CrBcHelpers::bSixtyFourEncode(CrBcHelpers::bSixtyFourDecode(JRequest::getVar('orig_url',''))) . '";

                    var suff = "?";
                    if(current_url.indexOf("?") !== -1){
                        suff = "&";
                    }

                    jQuery("#crbc-reload-currencies").load(current_url+suff+"gen_product_idx='.(JRequest::getInt('gen_product_idx', 0)+50).'&tmpl=component&orig_url="+orig_url);
                });
                </script> 
            ';
            
            $c = ob_get_contents();
            ob_end_clean();
            
            echo $c;
            exit;
            
        }
        
        // if the amount of products * amount of customer currencies is not equal to the currency price map amounts in total, then we need to trigger
        // a re-generation of the map
        
        $db->setQuery("Select Distinct count(b.id) From
                    #__breezingcommerce_products as b"
        );
        
        $amount_products = $db->loadResult();
        
        $db->setQuery("Select Distinct count(b.id) From
                    #__breezingcommerce_currencies as b"
        );
        
        $amount_currencies = $db->loadResult();
        
        $db->setQuery("Select count(a.currency_id)
                    FROM #__breezingcommerce_currency_price_map as a"
        );
        
        $amount_currencies2 = $db->loadResult();
        
        $has_orphans = false;
        
        if(($amount_currencies*$amount_products) != $amount_currencies2){
            
            $has_orphans = true;
        }
        
        if( $has_orphans ){
            
            JFactory::getDocument()->addScriptDeclaration('
                
                jQuery(document).ready(function(){
                    
                    var current_url = ' . CrBcHelpers::jsonEncode(JUri::getInstance()->toString()) . ';
                    var orig_url    = "' . CrBcHelpers::bSixtyFourEncode(JUri::getInstance()->toString()) . '";
                        
                    var suff = "?";
                    if(current_url.indexOf("?") !== -1){
                        suff = "&";
                    }

                    jQuery("body").css("pointer-events","none");
                    //jQuery("body").css("opacity","0.4");
                    
                    jQuery("#crbc-reload-currencies").load(current_url+suff+"gen_product_idx=0&tmpl=component&orig_url="+orig_url);
                });
            ');
            
            JFactory::getApplication()->enqueueMessage(JText::_('COM_BREEZINGCOMMERCE_REGEN_MSG'));
            
            return '<div id="crbc-reload-currencies"></div>';
        }
    }
    
    function generateForGroups(){
        
        $db = JFactory::getDbo();
        
        if( JRequest::getInt('gen_product_idx', -1) > -1 ){
            
            $db->setQuery("Select SQL_CACHE SQL_CALC_FOUND_ROWS id, producttaxclass_id From #__breezingcommerce_products", JRequest::getInt('gen_product_idx', 0), 50);
                
            $products = $db->loadObjectList();

            $db->setQuery('SELECT FOUND_ROWS();');
            $total = $db->loadResult();
            
            if( count($products) == 0 ){
                
                JFactory::getApplication()->enqueueMessage(JText::_('COM_BREEZINGCOMMERCE_REGEN_SUCCESS_MSG'));
                
                return '
                    <script>
                    jQuery(document).ready(function(){
                        location.href = '.  CrBcHelpers::jsonEncode(CrBcHelpers::bSixtyFourDecode(JRequest::getVar('orig_url',''))) . ';
                    });
                    </script>
                ';
            }
            
            foreach( $products As $product ){

                CrBcHelpers::addToGroupPriceMap($product->id, $product->producttaxclass_id);
            }
            
            @ob_end_clean();
            ob_start();
            
            echo '
                
            <div id="crbc-reload-group-progress">
                <div class="crbc-progress progress">
                    <div class="crbc-bar bar" style="width: '.((JRequest::getInt('gen_product_idx', 0)/$total) * 100).'%;"></div>
                </div>
                
            </div>
           <script type="text/javascript">
                jQuery(document).ready(function(){
                    
                    var current_url = '.  CrBcHelpers::jsonEncode(CrBcHelpers::bSixtyFourDecode(JRequest::getVar('orig_url',''))) . ';
                    var orig_url    = "'.  CrBcHelpers::bSixtyFourEncode(CrBcHelpers::bSixtyFourDecode(JRequest::getVar('orig_url',''))) . '";

                    var suff = "?";
                    if(current_url.indexOf("?") !== -1){
                        suff = "&";
                    }

                    jQuery("#crbc-reload-groups").load(current_url+suff+"gen_product_idx='.(JRequest::getInt('gen_product_idx', 0)+50).'&tmpl=component&orig_url="+orig_url);
                });
                </script> 
            ';
            
            $c = ob_get_contents();
            ob_end_clean();
            
            echo $c;
            exit;
            
        }
        
        // if the amount of products * amount of customer groups is not equal to the group price map amounts in total, then we need to trigger
        // a re-generation of the map
        
        $db->setQuery("Select Distinct count(b.id) From
                    #__breezingcommerce_products as b"
        );
        
        $amount_products = $db->loadResult();
        
        $db->setQuery("Select Distinct count(b.id) From
                    #__breezingcommerce_customergroups as b"
        );
        
        $amount_groups = $db->loadResult();
        
        $db->setQuery("Select count(a.customergroup_id)
                    FROM #__breezingcommerce_group_price_map as a"
        );
        
        $amount_groups2 = $db->loadResult();
        
        $has_orphans = false;
        
        if(($amount_groups*$amount_products) != $amount_groups2){
            
            $has_orphans = true;
        }
        
        if( $has_orphans ){
            
            JFactory::getDocument()->addScriptDeclaration('
                
                jQuery(document).ready(function(){
                    
                    var current_url = ' . CrBcHelpers::jsonEncode(JUri::getInstance()->toString()) . ';
                    var orig_url    = "' . CrBcHelpers::bSixtyFourEncode(JUri::getInstance()->toString()) . '";
                        
                    var suff = "?";
                    if(current_url.indexOf("?") !== -1){
                        suff = "&";
                    }

                    jQuery("body").css("pointer-events","none");
                    //jQuery("body").css("opacity","0.4");
                    
                    jQuery("#crbc-reload-groups").load(current_url+suff+"gen_product_idx=0&tmpl=component&orig_url="+orig_url);
                });
            ');
            
            JFactory::getApplication()->enqueueMessage(JText::_('COM_BREEZINGCOMMERCE_REGEN_MSG'));
            
            return '<div id="crbc-reload-groups"></div>';
        }
    }
}
