<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerCategories extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();

        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcCategoriesHelper.php' );

        // Register Extra tasks
        $this->registerTask( 'add', 'edit' );
    }

    function orderup() {
        $model = $this->getModel( 'category' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'category' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'categories' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart') );
    }

    function copy()
    {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        // due to rebuild issues, for now only one category can be copied at a time
        //if(count($cid) == 1)
        //{
            $model = $this->getModel( 'category' );
            $model->copy();
        //}
        //else if(count($cid) > 1)
        //{
        //    $model = $this->getModel( 'categories' );
        //    $model->copy();
        //}

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart'), JText::_('Category Copied') );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'category' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'categories' );
            $model->setPublished();
        }
        
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart'), JText::_('Category Published') );
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'category' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'categories' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart'), JText::_('Category Unpublished') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        jimport('joomla.html.pane');
        
        JRequest::setVar( 'view', 'category' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function apply()
    {
        $this->save(true);
    }

    function save($keep_task = false)
    {
        $model = $this->getModel('category');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CATEGORY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_CATEGORY' );
        }

        $additionalParams = '';
        if($keep_task){
            $id = JRequest::getInt('id', 0);
            if($id){
                $additionalParams = '&task=edit&cid[]='.$id;
            }
        }
        
        $link = 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart').$additionalParams;
        $this->setRedirect($link, $msg);
    }

    function saveNew()
    {
        $model = $this->getModel('category');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CATEGORY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_CATEGORY' );
        }

        $link = 'index.php?option=com_breezingcommerce&controller=categories&task=edit&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('category');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_CATEGORY_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CATEGORY_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'COM_BREEZINGCOMMERCE_OPERATION_CANCELLED' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=categories&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'categories');
        parent::display();
    }
}
