<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerFiles extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();

        JRequest::setVar('tmpl', 'component');
    }

    function orderup() {
        $model = $this->getModel( 'file' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'file' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'file' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart') );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) == 1)
        {
            $model = $this->getModel( 'file' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'files' );
            $model->setPublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart'), JText::_('File(s) published') );
    }

    function download(){
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcFile.php');
        CrBcFile::downloadFile(JRequest::getInt('file_id', 0), true);
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) == 1)
        {
            $model = $this->getModel( 'file' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'files' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart'), JText::_('File(s) unpublished') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'file' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function save()
    {
        $model = $this->getModel('file');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_FILE_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_FILE' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('file');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ONE_OR_MORE_FILES_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_FILES_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=files&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'files');

        parent::display();
    }
}
