<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerProductpropertycombinations extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();
        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );
        JRequest::setVar('tmpl', 'component');
        $this->registerTask( 'add', 'edit' );
    }

    function orderup() {
        $model = $this->getModel( 'productpropertycombination' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'productpropertycombination' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'productpropertycombination' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart') );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) == 1)
        {
            $model = $this->getModel( 'productpropertycombination' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'productpropertycombinations' );
            $model->setPublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart'), JText::_('Combination Published') );
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) == 1)
        {
            $model = $this->getModel( 'productpropertycombination' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'productpropertycombinations' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart'), JText::_('Combination Unpublished') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'productpropertycombination' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function apply()
    {
        $this->save(true);
    }

    function save($keep_task = false)
    {
        $model = $this->getModel('productpropertycombination');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_COMBINATION_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_COMBINATION' );
        }

        $additionalParams = '';
        if($keep_task){
            $id = JRequest::getInt('id', 0);
            if($id){
                $additionalParams = '&property_id='.JRequest::getInt('property_id',0).'&product_id='.JRequest::getInt('product_id',0).'&task=edit&cid[]='.$id;
            }
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart').$additionalParams;
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('productpropertycombination');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_COMBINATION_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_COMBINATION_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=productpropertycombinations&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'productpropertycombinations');

        parent::display();
    }
}

