<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerProperties extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();
        
        // Register Extra tasks
        $this->registerTask( 'add', 'edit' );
    }
    
    function readonly(){
        $model = $this->getModel( 'properties' );
        $msg = $model->setReadonly();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart') );
    }
    
    function unreadonly(){
        $model = $this->getModel( 'properties' );
        $msg = $model->unsetReadonly();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart') );
    }
    
    function export_readonly_properties()
    {
        $model = $this->getModel( 'property' );
        $msg = $model->exportPropertiesReadonly();
        JFactory::getApplication()->enqueueMessage( $msg );
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function export_properties()
    {
        $model = $this->getModel( 'property' );
        $msg = $model->exportProperties();
        JFactory::getApplication()->enqueueMessage( $msg );
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function export_properties_publish()
    {
        $model = $this->getModel( 'property' );
        $msg = $model->exportProperties(true);
        JFactory::getApplication()->enqueueMessage( $msg );
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }
    
    function export_readonly_properties_publish()
    {
        $model = $this->getModel( 'property' );
        $msg = $model->exportPropertiesReadonly(true);
        JFactory::getApplication()->enqueueMessage( $msg );
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function orderup() {
        $model = $this->getModel( 'property' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart') );
    }

    function listorderup() {
        $model = $this->getModel( 'property' );
        $model->listMove(-1);
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function orderdown() {
        $model = $this->getModel( 'property' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart') );
    }

    function listorderdown() {
        $model = $this->getModel( 'property' );
        $model->listMove(1);
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function saveorder(){
        $model = $this->getModel( 'properties' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart') );
    }

    function listsaveorder(){
        $model = $this->getModel( 'property' );
        $model->listSaveOrder();
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );

        parent::display();
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'property' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'property' );
            $model->setPublished();
        }
        
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart'), JText::_('Property Published') );
    }

    function listpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        $model = $this->getModel( 'property' );
        $model->setListPublished();

        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );

        parent::display();
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'property' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'property' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart'), JText::_('Property Unpublished') );
    }

    function listunpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        $model = $this->getModel( 'property' );
        $model->setListUnpublished();

        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );

        parent::display();
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        parent::display();
    }

    function apply()
    {
        $this->save(true);
    }

    function save($keep_task = false)
    {
        $model = $this->getModel('property');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_PROPERTY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_PROPERTY' );
        }

        $limit = 0;
        $additionalParams = '';
        if($keep_task){
            $id = JRequest::getInt('id', 0);
            if($id){
                $additionalParams = '&task=edit&cid[]='.$id;
                $limit = JRequest::getInt('limitstart');
            }
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.$limit.$additionalParams;
        $this->setRedirect($link, $msg);
    }

    function saveNew()
    {
        $model = $this->getModel('property');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_PROPERTY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_PROPERTY' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=properties&task=edit&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('property');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_PROPERTY_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_PROPERTY_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function listremove()
    {
        $model = $this->getModel('property');
        if(!$model->listDelete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_PROPERTY_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_PROPERTY_DELETED' );
        }

        JRequest::setVar( 'view', 'property' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart', 0) );

        parent::display();
    }

    function cancel()
    {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=properties&limitstart=0', $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'properties');
        
        parent::display();
    }
}
