<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.html.html');
jimport('joomla.form.formfield');

class JFormFieldCategoriesfilterpicker extends JFormField{

    function getInput()
    {
        //JHtml::_('behavior.modal', 'a.modal');
        JFactory::getDocument()->addScript(JURI::root(true) . '/components/com_breezingcommerce/js/remodal/remodal.min.js');
        JFactory::getDocument()->addScript(JUri::root(true).'/components/com_breezingcommerce/js/breezingcommerce.js');
        CrBcHelpers::addCssFile( JURI::root(true) . '/components/com_breezingcommerce/js/remodal/remodal.css' );
        CrBcHelpers::addCssFile( JURI::root(true) . '/components/com_breezingcommerce/js/remodal/remodal-default-theme.css' );
        
        JFactory::getDocument()->addScriptDeclaration("
            crbcLoadModal();
        ");
        
        JFactory::getLanguage()->load('com_breezingcommerce', JPATH_BASE, null, true);
        
        $out = '';
        
        $out .= '<script type="text/javascript">
            function crbc_categoriespicker_callback_' . $this->id . '(_list){

                for(var i = 0; i < _list.length; i++){
                    
                    var tuple = _list[i];
                    tuple.title = jQuery("<div>").text(tuple.title).html();
                    tuple.id = jQuery("<div>").text(tuple.id).html();
                    
                    if( jQuery("#crbc_category_title_'.$this->id.'_"+tuple.id).size() == 0 ){
                    
                        jQuery("#hidden_container_' . $this->id . '").append("<input type=\"hidden\" required=\"required\" name=\"' . $this->name . '[]\" id=\"' . $this->id . '"+tuple.id+"\" value=\""+tuple.id+"\"\/>");
                    
                        var js = "";
                        js += "<div id=\"select_' . $this->id . '"+tuple.id+"\" class=\"selected_category input-append\"><input title=\""+tuple.title+"\" style=\"width: 140px;\" type=\"text\" readonly=\"readonly\" id=\"crbc_category_title_'.$this->id.'_"+tuple.id+"\" name=\"crbc_category_title_'.$this->id.'[]\" value=\""+tuple.title+"\" size=\"40\"  \/>";
                        js += "<a class=\"btn btn-secondary\" href=\"javascript: crbc_categoriespicker_remove_' . $this->id . '(\'' . $this->id . '"+tuple.id+"\'); void(0);\"><span class=\"crbc-fa crbc-fa-remove\"></span><\/a>";
                        js += "<\/div>";
                        js += "<div style=\"clear:both;\"><\/div>";
                        jQuery("#selects_' . $this->id . '").append(js);
                    }
                }

                crbcCloseModal();
                
                if(typeof crbc_mod_filter != "undefined"){
                    crbc_mod_filter.performFilter(jQuery("#selects_'.$this->id.'").get(0));
                }
            }
            function crbc_categoriespicker_remove_' . $this->id . '(id){
                jQuery("#"+id).remove();
                jQuery("#select_"+id).remove();
                if(typeof crbc_mod_filter != "undefined"){
                    crbc_mod_filter.performFilter(jQuery("#selects_'.$this->id.'").get(0));
                }
            }
            function crbc_categoriespicker_reset_' . $this->id . '(){
                jQuery("#hidden_container_' . $this->id . '").html("");
                jQuery(".selected_category").remove();
                if(typeof crbc_mod_filter != "undefined"){
                    crbc_mod_filter.performFilter(jQuery("#selects_'.$this->id.'").get(0), true);
                }
            }
        </script>';
        
        $controller = 'categories';
        if( JFactory::getApplication()->isSite() ){
            $controller = 'categoriespicker';
        }
        
        $filter = JFactory::getSession()->get('com_breezingcommerce.module_filter', array());
        
        $out .= '<div>';
        
        // rel="{handler: \'iframe\', size: {x: 1024, y: 600}}"
        
        $out .= '<a data-remodal-width="850" data-remodal-height="500" class="crbc-select-categories remodal-trigger btn btn-secondary" href="'.JRoute::_('index.php?option=com_breezingcommerce&amp;controller='.$controller.'&amp;tmpl=component&amp;select=multiple&picker_callback=crbc_categoriespicker_callback_' . $this->id).'"><span class="crbc-fa crbc-fa-hand-pointer-o"></span> '.JText::_('COM_BREEZINGCOMMERCE_SELECT_CATEGORIES').'</a>';
        
        if(isset($filter['categories']) && count( $filter['categories'] ) > 0){
            $out .= ' <a id="crbc-reset-categories-' . $this->id . '" href="javascript:crbc_categoriespicker_reset_' . $this->id . '();void(0);" class="crbc-reset-categories btn btn-secondary"><span class="crbc-fa crbc-fa-remove"></span> '.JText::_('COM_BREEZINGCOMMERCE_CATEGORY_RESET').'</a>';
        }
        
        $out .= '</div>';
        
        $hidden = '';
        
        $out .= '<div id="selects_' . $this->id . '">';
        
        if(isset($filter['categories']) && count( $filter['categories'] ) > 0){
        
            JArrayHelper::toInteger($filter['categories']);
            
            $db = JFactory::getDbo();
            
            // make sure not to show categories that haven't been translated at least partially
            $check_for_translation_tbl = '';
            $check_for_translation_lookup = '';

            $default = JComponentHelper::getParams('com_languages')->get('site');
            if( count(JFactory::getLanguage()->getKnownLanguages()) > 1 && $default != JFactory::getLanguage()->getTag() ){

                $check_for_translation_tbl = ' Left Join #__breezingcommerce_translations As trns ';
                $check_for_translation_tbl .= ' On c.id = trns.item_id And trns.language_code = ' . $db->quote(JFactory::getLanguage()->getTag()) . ' And `type` = "category" ';
                $check_for_translation_lookup = ' And trns.item_id Is Not Null And ( trns.title <> "" Or trns.alias <> "" Or trns.body <> "" ) ';
            }
            
            $db->setQuery("Select c.* From #__breezingcommerce_categories As c $check_for_translation_tbl Where c.id In (".implode(',',$filter['categories']).") $check_for_translation_lookup");
            $categories = $db->loadObjectList();
        
            $i = 0;
            foreach( $categories As $category ){

                $translated_object = CrBcHelpers::loadTranslation($category->id, 'category');
                if($translated_object !== null){
                    $category->description = $translated_object->body;
                    $category->title = $translated_object->title;
                    $category->alias = $translated_object->alias;
                }
                
                $out .= '<div id="select_' . $this->id . $category->id . '" class="selected_category input-append"><input title="' . htmlentities($category->title, ENT_QUOTES, 'UTF-8') . '" style="width: 140px;" type="text" readonly="readonly" id="crbc_category_title_'.$this->id.'_'.$category->id.'" name="crbc_category_title_'.$this->id.'[]" value="' . htmlentities($category->title, ENT_QUOTES, 'UTF-8') . '" size="40"  />';
                $out .= '<a class="btn btn-secondary" href="javascript: crbc_categoriespicker_remove_' . $this->id . '(\'' . $this->id . $category->id . '\'); void(0);"><span class="crbc-fa crbc-fa-remove"></span></a>';
                $out .= '</div>';
                $hidden .= '<input type="hidden" required="required" name="' . $this->name . '[]" id="' . $this->id . $category->id . '" value="' . htmlentities($category->id, ENT_QUOTES, 'UTF-8') . '"/>';
                $i++;
            }
        }
        
        $out .= '</div>';
        
        $out .= '<span style="display:none;" id="hidden_container_' . $this->id . '">'.$hidden.'</span>';
        
        return $out;
    }
}