<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelProductattributeitem extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_product_attribute_items '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_product_attribute_items '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the images
    * @return array List of images
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select v.*,v2.`name` As item_name, v2.plus_price As item_plus_price, v2.product_id As item_item_product_id From #__breezingcommerce_product_attribute_items As v, #__breezingcommerce_attribute_items As v2 '.
                    '  Where v.attribute_item_id = v2.id And v.id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->product_id = 0;
            $this->_data->product_title = null;
            $this->_data->selected_product_title = null;
            $this->_data->item_plus_price = -1;
            $this->_data->item_item_product_id = 0;
            $this->_data->item_name = null;
            $this->_data->attribute_id = 0;
            $this->_data->product_attribute_id = null;
            $this->_data->attribute_item_id = null;
            $this->_data->name = null;
            $this->_data->published = null;
            $this->_data->ordering = null;
            $this->_data->plus_price = null;
            $this->_data->item_product_id  = null;
        }
        else
        {
            $this->_db->setQuery("Select title From #__breezingcommerce_products Where id = " . $this->_data->item_item_product_id);
            $this->_data->product_title = $this->_db->loadResult();
            $this->_db->setQuery("Select title From #__breezingcommerce_products Where id = " . $this->_data->item_product_id);
            $this->_data->selected_product_title = $this->_db->loadResult();
        }
        return $this->_data;

    }

    function store()
    {
        $row = $this->getTable('productattributeitems');

        $data = JRequest::get( 'post' );
        
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        
        $row->reorder('attribute_id = '.JRequest::getInt('key_id', 0).' And product_id = ' . JRequest::getInt('product_id', 0));
        
        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable('productattributeitems');

        foreach($cids as $cid) {
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
        }

        $row->reorder('attribute_id = '.JRequest::getInt('key_id', 0).' And product_id = ' . JRequest::getInt('product_id', 0));

        return true;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('productattributeitems');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'attribute_id = '.JRequest::getInt('key_id', 0).' And product_id = ' . JRequest::getInt('product_id', 0) )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('productattributeitems');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            $groupings[] = $row->product_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('attribute_id = '.JRequest::getInt('key_id', 0).' And product_id = '.(int) $group);
        }
    }
}
