<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelProductpropertycombination extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_product_property_combinations '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_product_property_combinations '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the images
    * @return array List of images
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select c.*, p.virtual_product From #__breezingcommerce_product_property_combinations As c, #__breezingcommerce_products As p '.
                    '  Where p.id = '.JRequest::getInt('product_id', 0).' And c.id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->product_id = 0;
            $this->_data->property_id = 0;
            $this->_data->virtual_product = 0;
            $this->_data->name = null;
            $this->_data->price = -1;
            $this->_data->stock = -1;
            $this->_data->ordering = 0;
            $this->_data->published = 0;
            $this->_data->selected = 0;
            $this->_data->weight = 0;
            $this->_data->width = 0;
            $this->_data->height = 0;
            $this->_data->length = 0;
            $this->_data->weight_type = null;
            $this->_data->dimension_type = null;
        }

        $this->_data->weight_type_big = 'kg';
        $this->_data->weight_type_small = 'g';
        $this->_data->weight_type_micro = 'mg';
        
        if( CrBcHelpers::getBcConfig()->get('weight_type',0) == 1){
            $this->_data->weight_type_big = 'lb';
            $this->_data->weight_type_small = 'oz';
            $this->_data->weight_type_micro = 'gr';
        }

        $this->_data->dimension_type_big = 'm';
        $this->_data->dimension_type_medium = 'dm';
        $this->_data->dimension_type_small = 'cm';
        $this->_data->dimension_type_micro = 'mm';
        
        if( CrBcHelpers::getBcConfig()->get('dimension_type',0) == 1 ){
            $this->_data->dimension_type_big = 'ft';
            $this->_data->dimension_type_small = 'in';
            $this->_data->dimension_type_medium = '';
            $this->_data->dimension_type_micro = ''; // no equivalent
        }

        $this->_db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'productprice' Order By `ordering`");
        $this->_data->price_plugins = $this->_db->loadObjectList();

        $this->_db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'productdetails' Order By `ordering`");
        $this->_data->display_plugins = $this->_db->loadObjectList();

        return $this->_data;

    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );

        if(trim($data['price']) == ''){
            $data['price'] = -1;
        }
        
        if(trim($data['stock']) == ''){
            $data['stock'] = 0;
        }

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $combination_id = 0;
        $storeRes = $row->store();

        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $combination_id = intval($data['id']);
            }
            else
            {
                $combination_id = $this->_db->insertid();
            }
        }
        
        $row->reorder('product_id = ' . JRequest::getInt('product_id', 0));

        $this->_db->setQuery("Delete From #__breezingcommerce_product_property_combination_items Where combination_id = " . $combination_id);
        $this->_db->query();

        $combination = JRequest::getVar('property_combination', array());
        foreach($combination As $key_id => $combo){
            if(intval($combo) > 0){
               $this->_db->setQuery("
                   Insert
                    Into
                   #__breezingcommerce_product_property_combination_items
                   (
                    combination_id,
                    product_id, 
                    property_id, 
                    property_key_id, 
                    property_value_id
                   )
                   Values
                   (
                    " . $combination_id . ",
                    " . JRequest::getInt('product_id', 0) . ",
                    " . JRequest::getInt('property_id', 0) . ",
                    " . intval($key_id) . ",
                    " . intval($combo) . "
                    )");
               
               $this->_db->query();
            }
        }

        $this->_db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'productprice' Order By `ordering`");
        $plugins = $this->_db->loadObjectList();
        foreach($plugins As $plugin){
            $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type);
            $class_instance = new $class();
            $class::viewportReceive(JRequest::getInt('product_id', 0), $combination_id, $data);
        }
        $plugin = array();
        $this->_db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'productdetails' Order By `ordering`");
        $plugins = $this->_db->loadObjectList();
        foreach($plugins As $plugin){
            $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type);
            $class_instance = new $class();
            $class::viewportReceive(JRequest::getInt('product_id', 0), $combination_id, $data);
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {

            $this->_db->setQuery("Delete From #__breezingcommerce_product_property_combination_items Where combination_id = " . $cid);
            $this->_db->query();

            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
        }

        $row->reorder('product_id = ' . JRequest::getInt('product_id', 0));

        return true;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('productpropertycombination');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'product_id = ' . JRequest::getInt('product_id', 0) )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('productpropertycombination');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            $groupings[] = $row->product_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('product_id = '.(int) $group);
        }
    }
}
