<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelProductpropertyvalue extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_product_property_values '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_product_property_values '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the images
    * @return array List of images
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select v.*,v2.value From #__breezingcommerce_product_property_values As v, #__breezingcommerce_property_values As v2 '.
                    '  Where v.property_value_id = v2.id And v.id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->product_id = 0;
            $this->_data->property_value_id = null;
            $this->_data->property_key_id = null;
            $this->_data->property_id = null;
            $this->_data->published = null;
            $this->_data->ordering = null;
            $this->_data->price = null;
            $this->_data->is_plus_price = null;
            $this->_data->custom_value = null;
        }
        
        // translations
        $this->_data->custom_value_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'productpropertyvalue' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->custom_value_translation = $translated_object->body;
            }
        }
        // translations end
        
        return $this->_data;

    }

    function store()
    {
        $row = $this->getTable('productpropertyvalues');

        $data = JRequest::get( 'post' );
        if(trim($data['price']) == ''){
            $data['price'] = -1;
        }
        if(trim($data['stock']) == ''){
            $data['stock'] = -1;
        }
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        
        $productpropertyvalue_id = 0;
        $store_res = $row->store();
        
        if (!$store_res) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $productpropertyvalue_id = intval($data['id']);
            }
            else
            {
                $productpropertyvalue_id = $this->_db->insertid();
            }
        }
        
        if( isset( $data['custom_value_translation'] ) ){
            $fields = array();
            $fields['body'] = $data['custom_value_translation'];
            CrBcHelpers::storeTranslation($fields, $productpropertyvalue_id, 'productpropertyvalue');
        }
        
        $row->reorder('property_key_id = '.JRequest::getInt('key_id', 0).' And product_id = ' . JRequest::getInt('product_id', 0));
        
        return true;
    }

    function delete()
    {
        
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable('productpropertyvalues');

        foreach($cids as $cid) {
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'productpropertyvalue' And item_id = " . $cid);
            $this->_db->query();
        }
        
        $row->reorder('property_key_id = '.JRequest::getInt('key_id', 0).' And product_id = ' . JRequest::getInt('product_id', 0));

        return true;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('productpropertyvalues');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'property_key_id = '.JRequest::getInt('key_id', 0).' And product_id = ' . JRequest::getInt('product_id', 0) )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('productpropertyvalues');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            $groupings[] = $row->product_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('property_key_id = '.JRequest::getInt('key_id', 0).' And product_id = '.(int) $group);
        }
    }
}
