<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelProductpropertyvalues extends JModelLegacy
{
    /**
     * Items total
     * @var integer
     */
    private $_total = null;

    /**
     * Pagination object
     * @var object
     */
    private $_pagination = null;

    function  __construct($config) {
        parent::__construct($config);

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $product_id = JRequest::getVar('product_id', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $product_id     = $mainframe->getUserStateFromRequest(  $option.'product_id', 'product_id', 0, 'int' );
        $this->setState('product_id', $product_id);

        $key_id     = $mainframe->getUserStateFromRequest(  $option.'key_id', 'key_id', 0, 'int' );
        $this->setState('key_id', $key_id);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'productpropertyvalues_filter_order', 'filter_order', 'ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'productpropertyvalues_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('productpropertyvalues_filter_order', $filter_order);
        $this->setState('productpropertyvalues_filter_order_Dir', $filter_order_Dir);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'productpropertyvalues_filter_state', 'filter_state', '', 'word' );
        $this->setState('productpropertyvalues_filter_state', $filter_state);
    }

    function setPublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_product_property_values '.
                '  Set published = 1 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();

    }

    function setUnpublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_product_property_values '.
                '  Set published = 0 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();
    }

    /*
     *
     * MAIN LIST AREA
     * 
     */

    /**
     * @return string The query
     */
    private function _buildQuery(){
        $published = '';
        if($this->getState('productpropertyvalues_filter_state') == 'P')
        {
            $published = ' ppv.published = 1 And ';
        }
        else if($this->getState('productpropertyvalues_filter_state') == 'U')
        {
            $published = ' ppv.published = 0 And ';
        }
        //echo 'Select SQL_CALC_FOUND_ROWS ppv.*, pv.`value` From #__breezingcommerce_product_property_values As ppv, #__breezingcommerce_property_values As pv Where '.$published.' ppv.property_key_id = '.$this->_db->Quote( $this->getState('key_id') ).' And ppv.product_id = ' . $this->_db->Quote( $this->getState('product_id') ) . ' And pv.id = ppv.property_value_id Order By ppv.`ordering`';
        return 'Select SQL_CALC_FOUND_ROWS ppv.*, pv.`value`, k.key As property_key From #__breezingcommerce_product_property_values As ppv, #__breezingcommerce_property_values As pv, #__breezingcommerce_property_keys As k Where ppv.property_key_id = k.id And '.$published.' ppv.property_key_id = '.$this->_db->Quote( $this->getState('key_id') ).' And ppv.product_id = ' . $this->_db->Quote( $this->getState('product_id') ) . ' And pv.id = ppv.property_value_id Order By ppv.`ordering`';
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable('productpropertyvalues');

        foreach($cids as $cid) {
            //echo "Delete From #__breezingcommerce_product_property_values Where product_id = ".$this->getState('product_id')." And property_key_id = " . $ppkid;
            $this->_db->setQuery("Delete From #__breezingcommerce_product_property_values Where id = ".$cid);
            $this->_db->query();
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'productpropertyvalue' And item_id = " . $cid);
            $this->_db->query();
            $this->_db->setQuery("Delete From #__breezingcommerce_product_property_combination_items Where property_key_id = ".$this->getState('key_id')." And product_id = ".$this->getState('product_id'));
            $this->_db->query();
            //echo "Delete From #__breezingcommerce_product_property_combination_items Where property_value_id = $cid And property_key_id = ".$this->getState('key_id')." And product_id = ".$this->getState('product_id');
            //echo $this->_db->getErrorMsg();
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
            }
        }

        $row->reorder('property_key_id = '.$this->getState('key_id').' And product_id = '.$this->getState('product_id'));

        return true;
    }

    /**
    * Gets the currencies
    * @return array List of currencies
    */
    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_data;
    }

    function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

}
