<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelTaxrate extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setDefault()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_taxrates '.
                        '  Set `default` = 0' );
            $this->_db->query();
            
            $this->_db->setQuery( ' Update #__breezingcommerce_taxrates '.
                        '  Set `default` = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_taxrates '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_taxrates '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the taxrates
    * @return array List of taxrates
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_taxrates '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->name = null;
            $this->_data->country_id = 0;
            $this->_data->region_id = 0;
            $this->_data->is_range = null;
            $this->_data->range_from = null;
            $this->_data->range_to = null;
            $this->_data->zip_code = null;
            $this->_data->rate_percent = null;
            $this->_data->published = null;
            $this->_data->ordering = null;
            $this->_data->countries = array();
        }
        $query = ' Select * From #__breezingcommerce_countries ';
        $this->_db->setQuery($query);
        $this->_data->countries = $this->_db->loadObjectList();
        foreach ($this->_data->countries As $country) {
            $country->regions = array();
            $query = ' Select * From #__breezingcommerce_country_regions Where country_id = ' . $country->id;
            $this->_db->setQuery($query);
            $regions = $this->_db->loadObjectList();
            foreach ($regions As $region) {
                $country->regions[] = $region;
            }
        }
        $this->_db->setQuery("Select * From #__breezingcommerce_translations Where item_id = ".$this->_id." And type = 'taxrate' And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
        $name_translation = $this->_db->loadObject();
        $this->_data->name_translation = '';
        if($name_translation !== null){
            $this->_data->name_translation = $name_translation->title;
        }
        return $this->_data;

    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );
        if(trim($data['zip_code']) == ''){
            $data['zip_code'] = '*';
        }

        if(doubleval(trim($data['weight'])) <= 0){
            $data['weight'] = 0;
        }

        if(doubleval(trim($data['rate_percent'])) <= 0){
            $data['rate_percent'] = 0;
        }
        
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $taxrate_id = 0;
        $storeRes = $row->store();
        
        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }else{
            if( intval($data['id']) != 0 )
            {
                $taxrate_id = intval($data['id']);
            }
            else
            {
                $taxrate_id = $this->_db->insertid();
            }
        }
        
        $row->reorder();

        if(isset($data['name_translation']) && $data['name_translation'] != ''){
            $fields = array();
            $fields['title'] = trim($data['name_translation']);
            CrBcHelpers::storeTranslation($fields, $taxrate_id, 'taxrate');
        }
        
        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
            else{
                $this->_db->setQuery("Delete From #__breezingcommerce_taxrules_taxrates Where taxrate_id = " . $cid);
                $this->_db->query();
            }
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where item_id = ".$cid." And type = 'taxrate'");
            $this->_db->query();
        }

        $row->reorder();

        return true;
    }


    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('taxrate');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }
}
