<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    
    jQuery(document).ready(function(){
        var data = {
        labels: <?php echo CrBcHelpers::jsonEncode($this->sales_data_units); ?>,
        series: [
          <?php
          $sales_series_all_size = count($this->sales_series);
          $j = 0;
          foreach($this->sales_series As $sales_series){
              echo '[';
              $sales_series_size = count($sales_series);
              $i = 0;
              foreach($sales_series As $series_value){
                $show = 0;
                switch(JRequest::getVar('sale_chart_filter','')){
                    case 'net':
                        $show = $series_value['net'];
                        break;
                    case 'taxes':
                        $show = $series_value['taxes'];
                        break;
                    default:
                        $show = $series_value['gross'];
                }
                echo '{meta: '.CrBcHelpers::jsonEncode($series_value['sales'].' x '.$series_value['currency_code'] . ': ').', value: '.CrBcHelpers::jsonEncode($show).'}';
                if($i+1 < $sales_series_size){
                    echo ',';
                }
                $i++;
              }
              echo ']';
              if( $j + 1 < $sales_series_all_size ){
                  echo ',';
              }
              $j++;
          }
          ?>
        ]
      };

      var options = {
        seriesBarDistance: 10,
        stackBars: true,
        axisX: {
            
        },
        plugins: [
          Chartist.plugins.tooltip({
              tooltipFnc : function(meta, value){
                  return meta + " " + Number(value).toFixed(2);
              }
          })
        ]
      };
      
      var responsiveOptions = [
        ['screen and (max-width: 640px)', {
          seriesBarDistance: 5,
          axisX: {
           showGrid: false,
           showLabel: false 
          }
        }]
      ];

      new Chartist.Bar('.ct-chart', data, options, responsiveOptions);
    });
</script>
<div id="adminForm">
<div class="crbc-row row-fluid">
    <div class="crbc-span4 span4">
        <div class="crbc-well well well-small">
            <h3 style="text-align: center;"><i class="crbc-dashboard-icon crbc-fa crbc-fa-shopping-cart" class="pull-left"></i> <?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL_ORDERS'); ?></h3>
            <h2 style="text-align: center;"><?php echo $this->total_orders; ?></h2>
        </div>
    </div>
    <div class="crbc-span4 span4">
        <div class="crbc-well well well-small">
            <h3 style="text-align: center;"><i class="crbc-dashboard-icon crbc-fa crbc-fa-money" class="pull-left"></i> <?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL_SALES'); ?></h3>
            <?php
            foreach($this->total_sales As $sales_total){
            ?>
            <h2 style="text-align: center;"><?php echo $sales_total->history_symbol; ?><?php echo CrBcCart::formatNumber($sales_total->sales_total,'.',''); ?> <?php echo $sales_total->history_currency_code; ?></h2>
            <?php
            }
            ?>
        </div>
    </div>
    <div class="crbc-span4 span4">
        <div class="crbc-well well well-small">
            <h3 style="text-align: center;"><i class="crbc-dashboard-icon crbc-fa crbc-fa-user" class="pull-left"></i> <?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL_CUSTOMERS'); ?></h3>
            <h2 style="text-align: center;"><?php echo $this->total_customers; ?></h2>
        </div>
    </div>
</div>
<div class="crbc-row row-fluid">
    <div class="crbc-sales-chart crbc-span6 span6">
        <div class="crbc-well well well-small">
            <h3 class="pull-left"><i class="crbc-dashboard-icon crbc-fa crbc-fa-bar-chart" class="pull-left"></i> <?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_SALES_STATS'); ?></h3>
            <div class="pull-right">
                <?php JHtml::_('formbehavior.chosen', '#sale_chart_choosen'); ?>
                <?php JHtml::_('formbehavior.chosen', '#sale_chart_filter'); ?>
                <form id="sale_chart_form" action="index.php" method="get">
                    <select onchange="jQuery('#sale_chart_form').trigger('submit');" name="sale_chart_choosen" id="sale_chart_choosen">
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'today' ? 'selected="selected" ' : '' ?>value="today"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_TODAY');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'yesterday' ? 'selected="selected" ' : '' ?>value="yesterday"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_YESTERDAY');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'this-week' ? 'selected="selected" ' : '' ?>value="this-week"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_THIS_WEEK');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'last-week' ? 'selected="selected" ' : '' ?>value="last-week"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_LAST_WEEK');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'this-month' ? 'selected="selected" ' : '' ?>value="this-month"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_THIS_MONTH');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'last-month' ? 'selected="selected" ' : '' ?>value="last-month"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_LAST_MONTH');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'this-year' ? 'selected="selected" ' : '' ?>value="this-year"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_THIS_YEAR');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_choosen','') == 'last-year' ? 'selected="selected" ' : '' ?>value="last-year"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_LAST_YEAR');?></option>
                    </select>
                    <div id="sale_chart_choosen_distance"></div>
                    <select onchange="jQuery('#sale_chart_form').trigger('submit');" name="sale_chart_filter" id="sale_chart_filter">
                        <option <?php echo JRequest::getVar('sale_chart_filter','') == 'gross' ? 'selected="selected" ' : '' ?>value="gross"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_SHOW_GROSS');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_filter','') == 'net' ? 'selected="selected" ' : '' ?>value="net"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_SHOW_NET');?></option>
                        <option <?php echo JRequest::getVar('sale_chart_filter','') == 'taxes' ? 'selected="selected" ' : '' ?>value="taxes"><?php echo JText::_('COM_BREEZINGCOMMERCE_DASHBOARD_CHART_SHOW_TAXES');?></option>
                    </select>
                    <input type="hidden" name="option" value="com_breezingcommerce" />
                </form>
            </div>
            <div class="clearfix"></div>
            <div class="ct-chart ct-golden-section"></div>
        </div>
    </div>
    <div class="crbc-span6 span6">
        <div class="crbc-well well well-small">
            <h3><i class="crbc-dashboard-icon crbc-fa crbc-fa-shopping-cart" class="pull-left"></i> <?php echo JText::_('COM_BREEZINGCOMMERCE_ORDERS'); ?></h3>
            <div class="row-striped">
                <?php
                foreach( $this->latest_orders As $latest_order ){
                    $link = JRoute::_( 'index.php?option=com_breezingcommerce&controller=orders&task=edit&cid[]='. $latest_order->id);
                ?>
                <div class="row-fluid">
                    <div class="span6"><span class="row-title break-word"><a href="<?php echo $link; ?>"><?php echo $latest_order->history_customer_name; ?></a></span></div>
                    <div class="span3"><?php echo $latest_order->order_total ? $latest_order->history_symbol . number_format(round($latest_order->order_total,2),2,'.',',') : JText::_('COM_BREEZINGCOMMERCE_NOT_CHECKED_OUT_YET'); ?></div>
                    <div class="span3"><span class="small"><i class="crbc-fa crbc-fa-calendar"></i> <?php echo JHTML::_('date', $latest_order->creation_date, JText::_('DATE_FORMAT_LC2'), false); ?></span></div>
                </div>
                <?php
                }
                ?>
            </div>
        </div>
    </div>
</div>
</div>


