<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class BreezingcommerceViewBreezingcommerce extends JViewLegacy
{
    function display($tpl = null)
    {
        require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'classes'.DS.'CrBcCart.php');
        
        JToolBarHelper::title(  'BreezingCommerce: ' .  JText::_( 'COM_BREEZINGCOMMERCE_DASHBOARD' ), 'bcart' );
        
        JFactory::getDocument()->addStyleSheet(JUri::root(true).'/components/com_breezingcommerce/js/chartist/chartist.min.css');
        JFactory::getDocument()->addScript(JUri::root(true).'/components/com_breezingcommerce/js/chartist/chartist.min.js');
        JFactory::getDocument()->addStyleSheet(JUri::root(true).'/components/com_breezingcommerce/js/chartist/plugins/tooltip/chartist-plugin-tooltip.css');
        JFactory::getDocument()->addScript(JUri::root(true).'/components/com_breezingcommerce/js/chartist/plugins/tooltip/chartist-plugin-tooltip.js');
        
        $today = true;
        $daily = false;
        $yearly = false;
        
        if( in_array(JRequest::getVar('sale_chart_choosen',''), array('this-week','last-week')) ){
            
            $today = false;
            $daily = true;
        }
        else
        if( in_array(JRequest::getVar('sale_chart_choosen',''), array('this-year','last-year')) ){
            
            $today = false;
            $daily = false;
            $yearly = true;
        }
        
        $sales_data   = $this->get('SalesData');
        $this->assignRef('sales_data', $sales_data);
        
        $sales_data_units = array();
        foreach( $sales_data As $key => $value ){
            
            if( $daily ){
                
                switch( $key ){
                    case '1': $key = JText::_('MON'); break;
                    case '2': $key = JText::_('TUE'); break;
                    case '3': $key = JText::_('WED'); break;
                    case '4': $key = JText::_('THU'); break;
                    case '5': $key = JText::_('FRI'); break;
                    case '6': $key = JText::_('SAT'); break;
                    case '7': $key = JText::_('SUN'); break;
                }
                
            }
            else
            if( $yearly ){
                
                switch( $key ){
                    case '1': $key = JText::_('JANUARY_SHORT'); break;
                    case '2': $key = JText::_('FEBRUARY_SHORT'); break;
                    case '3': $key = JText::_('MARCH_SHORT'); break;
                    case '4': $key = JText::_('APRIL_SHORT'); break;
                    case '5': $key = JText::_('MAY_SHORT'); break;
                    case '6': $key = JText::_('JUNE_SHORT'); break;
                    case '7': $key = JText::_('JULY_SHORT'); break;
                    case '8': $key = JText::_('AUGUST_SHORT'); break;
                    case '9': $key = JText::_('SEPTEMBER_SHORT'); break;
                    case '10': $key = JText::_('OCTOBER_SHORT'); break;
                    case '11': $key = JText::_('NOVEMBER_SHORT'); break;
                    case '12': $key = JText::_('DECEMBER_SHORT'); break;
                }
                
            }
            
            $sales_data_units[] = $key;
        }
        $this->assignRef('sales_data_units', $sales_data_units);
        
        $sales_series = array();
        foreach( $sales_data As $key => $currencies ){
            
            foreach($currencies As $currency_key => $currency){
                $sales_series[$currency_key][$key] = $currency;
            }
        }
        
        $this->assignRef('sales_series', $sales_series);
        
        $latest_orders   = $this->get('LatestOrders');
        $this->assignRef('latest_orders', $latest_orders);
        
        $total_orders   = $this->get('TotalOrders');
        $this->assignRef('total_orders', $total_orders);
        
        $total_sales   = $this->get('TotalSales');
        $this->assignRef('total_sales', $total_sales);
        
        $total_customers   = $this->get('TotalCustomers');
        $this->assignRef('total_customers', $total_customers);
        
        parent::display($tpl);
    }
}
