<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class BreezingcommerceViewOrder extends JViewLegacy
{
    function display($tpl = null)
    {
        require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/CrBcPane.php');

        $order     = $this->get('Order');
        $cart_instance     = $this->get('CartInstance');
        $order_items   = $this->get('Data');
        $log   = $this->get('Log');

        $pagination   = $this->get('Pagination');
        $isNew        = ($order->id < 1);

        $text = $isNew ? JText::_( 'COM_BREEZINGCOMMERCE_DETAILS' ) : JText::_( 'COM_BREEZINGCOMMERCE_DETAILS' );
        JToolBarHelper::title(  'BreezingCommerce: ' .  JText::_( 'COM_BREEZINGCOMMERCE_ORDER' ).': <small><small>[ '.($order->order_number ? $order->order_number : $text). ' ]</small></small>', 'bcart' );

        JToolBarHelper::apply();
        JToolBarHelper::save();
        JToolBarHelper::custom('copy', 'copy', '', JText::_('COM_BREEZINGCOMMERCE_COPY'),false);

        if(!$order->invoice_created){
            JToolBarHelper::deleteList();
        }
        if(!$order->checked_out){
            JToolBarHelper::custom('checkout', 'default', '', JText::_('COM_BREEZINGCOMMERCE_CHECKOUT'), false);
        }else{
            if(!$order->invoice_created){
                JToolBarHelper::custom('create_invoice', 'default', '', JText::_('COM_BREEZINGCOMMERCE_ORDER_CREATE_INVOICE'), false);
            }else if(!$order->cancelled){
                JToolBarHelper::custom('cancel_order', 'default', '', JText::_('COM_BREEZINGCOMMERCE_ORDER_CANCEL_ORDER'), false);
            }
        }

        JToolBarHelper::custom('print_packing_slip', 'default', '', JText::_('COM_BREEZINGCOMMERCE_PRINT_PACKING_SLIP'),false);

        JToolBarHelper::custom('verify', 'publish', '', JText::_('COM_BREEZINGCOMMERCE_VERIFY'),true);
        JToolBarHelper::custom('unverify', 'unpublish', '', JText::_('COM_BREEZINGCOMMERCE_UNVERIFY'),true);

        if ($isNew) {
            JToolBarHelper::cancel();
        } else {
            // for existing items the button is renamed `close`
            JToolBarHelper::cancel( 'cancel', JText::_('COM_BREEZINGCOMMERCE_CLOSE') );
        }

        $state = $this->get( 'state' );
        $lists['order_Dir'] = $state->get( 'orderitems_filter_order_Dir' );
        $lists['order'] = $state->get( 'orderitems_filter_order' );
        $lists['limitstart'] = $state->get( 'limitstart' );

        // CART PLUGINS INIT - BEGIN
        $db = JFactory::getDbo();
        $db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'cart' Order By `ordering`");
        $cart_plugins = $db->loadAssocList();
        
        $cart_plugin_instances = array();
        foreach( $cart_plugins As $plugin ){
            $plugin_instance = CrBcPlugin::getPluginInstance($plugin['name'], $plugin['type'], 'admin');
            if($plugin_instance instanceof CrBcCartAdminPlugin){
                if($plugin_instance->isSuitable() !== false){
                    $plugin_instance->init($cart_instance);
                    $cart_plugin_instances[] = $plugin_instance;
                }
            }
        }
        
        $this->assignRef('cart_plugins', $cart_plugin_instances);
        // CART PLUGINS INIT - END
        
        $ordering = ($lists['order'] == 'ordering');

        $tmpl = JRequest::getWord('tmpl','');
        $this->assignRef('tmpl', $tmpl);
        $layout = JRequest::getWord('layout','default');
        $this->assignRef('layout', $layout);
        $this->assignRef('ordering', $ordering);
        $this->assignRef('order', $order);
        $this->assignRef('log', $log);
        
        // applying productdisplay order item handlers
        // productdetails PLUGINS INIT - BEGIN
        
        $db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'productdetails' Order By `ordering`");
        $productdetails_plugins = $db->loadAssocList();
        
        $cnt = count($order_items);
        for($i = 0; $i < $cnt; $i++){
            
            $productdetails_plugin_instances = array();
            foreach( $productdetails_plugins As $plugin ){

                $plugin_instance = CrBcPlugin::getPluginInstance($plugin['name'], $plugin['type'], 'admin');
                if($plugin_instance instanceof CrBcProductdetailsAdminPlugin){
                    $plugin_instance->init($cart_instance);
                    $info = $plugin_instance->handleOrderItemDisplay($order_items[$i]->order_item_info);
                    $order_items[$i]->order_item_info = $info;
                }
            }
            // PRODUCTDETAILS PLUGINS INIT - END
        }
         
        $this->assignRef('items', $order_items);
        
        
        $this->assignRef( 'pagination', $pagination );

        $state = $this->get( 'state' );
        $start_offset = $state->get( 'order_tabStartOffset'.$this->getModel()->getId() );
        $this->assignRef('tabStartOffset', $start_offset);
        parent::display($tpl);
    }
}
