<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
            case 'saveNew':
            case 'apply':
                var error = false;
                var categorySelected = false;

                if (jQuery('input[name="categories[categories][]"]').size() > 0) {
                    categorySelected = true;
                }

                if(typeof crbcValidateAttributes != "undefined" && !crbcValidateAttributes()){
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_REQUIRED_ATTRIBUTES')) ?>");
                    error = true;
                }
                else
                if(document.getElementById('title').value == '')
                {
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_TITLE')) ;?>");
                    error = true;
                }
                else if(document.getElementById('price').value == '')
                {
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_PRICE')) ;?>");
                    error = true;
                }
                else if( isNaN( document.getElementById('price').value) || ( !isNaN( document.getElementById('price').value ) && Number( document.getElementById('price').value ) < 0 ) )
                {
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_VALID_PRICE')) ;?>");
                    error = true;
                }
                else if( document.getElementById('sale_price').value != '' && isNaN( document.getElementById('sale_price').value) || ( !isNaN( document.getElementById('sale_price').value ) && Number( document.getElementById('sale_price').value ) < 0 ) )
                {
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_VALID_SALE_PRICE')) ;?>");
                    error = true;
                }
                else if(!categorySelected)
                {
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_SELECT_CAT')) ;?>");
                    error = true;
                }
                else if(document.getElementById('product_file').value != '')
                {
                    if(document.getElementById('file_name').value == '')
                    {
                        alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_FILENAME')) ;?>");
                        error = true;
                    }
                }

                if(!error)
                {
                    submitform(pressbutton);
                }

                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>
<?php
$pane = new CrBcPane();
echo $pane->initPane(
    array(
        'product-pane' => JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT' ),
        'image-pane' => JText::_( 'COM_BREEZINGCOMMERCE_IMAGES' ),
        'files-pane' => JText::_( 'COM_BREEZINGCOMMERCE_FILES' ),
        'weight-pane' => JText::_( 'COM_BREEZINGCOMMERCE_WEIGHT_DIMENSIONS' ),
        'properties-pane' => JText::_( 'COM_BREEZINGCOMMERCE_PROPERTIES' ),
        //'attributes-pane' => JText::_( 'COM_BREEZINGCOMMERCE_ATTRIBUTES' ),
        'manufacturers-pane' => JText::_( 'COM_BREEZINGCOMMERCE_MANUFACTURERS' ),
        'cart-pane' => JText::_( 'COM_BREEZINGCOMMERCE_CART' ),
        'priceplugins-pane' => JText::_( 'COM_BREEZINGCOMMERCE_PRICE_PLUGINS' ),
        'displayplugins-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DISPLAY_PLUGINS' ),
        'parametersadvanced-pane' => JText::_( 'COM_BREEZINGCOMMERCE_PARAMETERS__ADVANCED' ),
        //'metadata-pane' => JText::_( 'COM_BREEZINGCOMMERCE_METADATA_INFORMATION' )
    )
    ,
    array(
        'priceplugins-pane' => count($this->product->price_plugins) > 0,
        'displayplugins-pane' => count($this->product->display_plugins) > 0
    )
);
?>
<form action="index.php" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="inner-main">
    <?php
    echo $pane->startPane();
    echo $pane->startPanel( 'product-pane' );
    ?>
    <div class="row-fluid">
        <div class="span9">
            <div class="form-horizontal">

                <?php
                // translations
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                    $pane2 = new CrBcPane();
                    echo $pane2->initPane(
                        array(
                            'translation-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                            'original-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                        )
                    );

                    echo $pane2->startPane();
                    echo $pane2->startPanel( 'translation-pane' );
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="title_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_TITLE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_TITLE' ); ?></label>
                    </div>
                    <div class="controls">
                        <input class="input-xxlarge input-large-text ct-input-large-fullwidth" type="text" name="title_translation" id="title_translation" maxlength="255" value="<?php echo htmlentities( $this->product->title_translation, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="alias_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_ALIAS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_ALIAS' ); ?></label>
                    </div>
                    <div class="controls">
                        <input class="input-xxlarge input-large-text ct-input-large-fullwidth" type="text" name="alias_translation" id="alias_translation" maxlength="255" value="<?php echo htmlentities( $this->product->alias_translation, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="description_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DESCRIPTION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                        JImport( 'joomla.html.editor' );
                        $editor = JFactory::getEditor();
                        echo $editor->display("description_translation",$this->product->description_translation, '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                    echo $pane2->endPanel();
                    echo $pane2->startPanel( 'original-pane' );
                }

                // default (all) case
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="title" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_TITLE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_TITLE' ); ?></label>
                    </div>
                    <div class="controls">
                        <input class="input-xxlarge input-large-text ct-input-large-fullwidth" type="text" name="title" id="title" maxlength="255" value="<?php echo htmlentities( $this->product->title, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="alias" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_ALIAS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_ALIAS' ); ?></label>
                    </div>
                    <div class="controls">
                        <input class="input-xxlarge input-large-text ct-input-large-fullwidth" type="text" name="alias" id="alias" maxlength="255" value="<?php echo htmlentities( $this->product->alias, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="description" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DESCRIPTION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                        JImport( 'joomla.html.editor' );
                        $editor = JFactory::getEditor();
                        echo $editor->display("description",$this->product->description, '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                    echo $pane2->endPanel();
                    echo $pane2->endPane();
                }
                // translations end
                ?>

            </div>
        </div>

        <div class="span3 category-sidebar">

            <fieldset class="form-vertical">

                <div class="control-group">
                    <div class="control-label">
                        <label for="price" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRICE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRICE' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="price" id="price" maxlength="69" value="<?php echo htmlentities( $this->product->price, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="sale_price" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_SALE_PRICE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_SALE_PRICE' ); ?></label>
                    </div>
                    <div class="controls">
                        <input class="text_area" type="text" name="sale_price" id="sale_price" size="40" maxlength="69" value="<?php echo htmlentities( $this->product->sale_price, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="item_number" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_ITEM_NUMBER_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_ITEM_NUMBER' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="item_number" id="item_number" maxlength="255" value="<?php echo htmlentities( $this->product->item_number, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="sku" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_SKU_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_SKU' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="sku" id="sku" maxlength="255" value="<?php echo htmlentities( $this->product->sku, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="producttaxclass_id" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_TAX_CLASS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_TAX_CLASS' ); ?></label>
                    </div>
                    <div class="controls">
                        <select name="producttaxclass_id" id="producttaxclass_id" class="chzn-done">
                            <option value="0"><?php echo JText::_('None');?></option>
                            <?php
                            foreach($this->product->taxclasses As $taxclass){
                               echo '<option value="'.$taxclass->id.'"'.($taxclass->selected ? ' selected="selected"' : '').'>'.htmlentities($taxclass->name, ENT_QUOTES, 'UTF-8').'</option>'."\n";
                            }
                            ?>
                        </select>
                    </div>
                </div>

                <div class="control-group">
                    <?php
                    if(!$this->product->use_combinations && !$this->product->virtual_product){
                    ?>
                    <div class="control-label">
                        <label for="stock" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="stock" id="stock"  maxlength="255" value="<?php echo htmlentities( $this->product->stock, ENT_QUOTES, 'UTF-8');?>" title="" />
                    </div>
                    <?php } else { ?>

                    <div class="control-label">
                        <label for="stock" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                        if($this->product->virtual_product){
                        ?>
                        <i><?php echo JText::_('COM_BREEZINGCOMMERCE_VIRTUAL_PRODUCT');?></i>
                        <?php
                        } else {
                        ?>
                        <i><?php echo JText::_('COM_BREEZINGCOMMERCE_SEE_PROPERTIES');?></i>
                        <?php
                        }
                        ?>
                        <input type="hidden" name="stock" value="<?php echo htmlentities( $this->product->stock < 0 ? 0 : $this->product->stock, ENT_QUOTES, 'UTF-8');?>"/>
                    </div>

                    <?php
                    }
                    ?>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                        $yesChecked = '';
                        $noChecked = ' checked="checked"';
                        if($this->product->published)
                        {
                            $yesChecked = ' checked="checked"';
                            $noChecked = '';
                        }
                        ?>
                        <fieldset id="published_fieldset" class="radio btn-group btn-group-yesno">
                            <input type="radio" name="published" id="published_1" value="0" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?>" <?php echo $noChecked;?>/>
                            <label for="published_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                            <input type="radio" name="published" id="published_2" value="1" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?>" <?php echo $yesChecked;?>/>
                            <label for="published_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        </fieldset>
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_VIRTUAL_PRODUCT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_VIRTUAL_PRODUCT' ); ?></label>
                    </div>
                    <div class="controls">

                        <?php
                        $yesChecked = '';
                        $noChecked = ' checked="checked"';
                        if($this->product->virtual_product)
                        {
                            $yesChecked = ' checked="checked"';
                            $noChecked = '';
                        }
                        ?>
                        <fieldset id="virtual_product_fieldset" class="radio btn-group btn-group-yesno">
                            <input type="radio" name="virtual_product" id="virtual_product_1" value="0" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?>" <?php echo $noChecked;?>/>
                            <label for="virtual_product_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                            <input type="radio" name="virtual_product" id="virtual_product_2" value="1" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?>" <?php echo $yesChecked;?>/>
                            <label for="virtual_product_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        </fieldset>

                    </div>
                </div>

                <div class="control-label">
                    <label for="categories" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_CATEGORIES_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CATEGORIES' ); ?></label>
                </div>
                <div class="controls">
                    <?php //JHtml::_('formbehavior.chosen', '#categories'); ?>
                    <?php //echo CrBcCategoriesHelper::getCategoriesMultipleSelectList($this->categories, 'categories[]', 20, '', 'width: 100%;'); ?>

                    <?php
                    echo CrBcForm::render(
                        array(
                            'categories'
                        ),
                        '{"categories":'.json_encode("").'}',
                        'helper',
                        'advanced',
                        'categories',
                        true
                    );
                    ?>

                </div>

                <?php if ($this->product->id) { ?>
                    <div class="control-group">
                        <div class="control-label">
                            <?php echo JText::_( 'COM_BREEZINGCOMMERCE_ID' ); ?> <?php echo $this->product->id; ?>
                        </div>
                    </div>
                <?php } ?>

                <!--
                <div class="control-group">
                    <div class="control-label">
                        <?php echo JText::_( 'COM_BREEZINGCOMMERCE_HITS' ); ?> 999

                        
                        <span style="display: none; visibility: hidden">
                            <input name="reset_hits" type="button" class="button" value="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_RESET' ); ?>" onclick="submitbutton('resethits');" />
                        </span>
                        

                    </div>
                </div>
                -->
                <div class="control-group">
                    <div class="control-label">
                        <?php echo JText::_( 'COM_BREEZINGCOMMERCE_CREATED' ); ?>
                        <?php
                        $db = JFactory::getDBO();
                        $create_date = null;
                        $nullDate = $db->getNullDate();
                        if ( $this->product->created == $nullDate ) {
                            echo JText::_( 'COM_BREEZINGCOMMERCE_NEW_PRODUCT' );
                        } else {
                            echo JHTML::_('date',  $this->product->created,  JText::_('DATE_FORMAT_LC2'), false ) . ' (' . $this->product->created_by_alias . ')';
                        }
                        ?>
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                       <?php echo JText::_( 'COM_BREEZINGCOMMERCE_MODIFIED' ); ?>
                       <?php
                       if ( $this->product->modified == $nullDate ) {
                            echo JText::_( 'COM_BREEZINGCOMMERCE_NOT_MODIFIED' );
                       } else {
                            echo JHTML::_('date',  $this->product->modified, JText::_('DATE_FORMAT_LC2'), false) . ' (' . $this->product->modified_by_alias . ')';
                       }
                       ?>
                    </div>
                </div>

            </fieldset>

        </div>

    </div>

    <?php
    echo $pane->endPanel();
    echo $pane->startPanel( 'image-pane' );
    ?>

    <div class="row-fluid">
        <div class="span12">
            <div class="form-horizontal">

                <div class="control-group">
                    <div class="control-label">&nbsp;
                    </div>
                    <div class="controls">
                        <a href="index.php?option=com_breezingcommerce&amp;controller=images&amp;product_id=<?php echo $this->product->id; ?>" title="<?php echo JText::_('COM_BREEZINGCOMMERCE_EDIT_IMAGES');?>" class="modal" rel="{handler: 'iframe', size: {x: 1024, y: 500}}"><?php echo JText::_('COM_BREEZINGCOMMERCE_EDIT_IMAGES');?></a> (<?php echo $this->amount_images;?>)
                    </div>
                </div>

                <fieldset>
                    <legend><?php echo JText::_('COM_BREEZINGCOMMERCE_NEW');?></legend>

                <div class="control-group">
                    <div class="control-label">
                        <label for="product_image" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IMAGE' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="file" name="product_image" id="product_image" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="image_name" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="image_name" id="image_name" value="" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="background_color" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_BACKGROUND_COLOR_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_BACKGROUND_COLOR' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" maxlength="6" name="background_color" id="background_color" value="" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PUBLISHED_IMAGE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?></label>
                    </div>
                    <div class="controls">
                        <fieldset id="image_published_fieldset" class="radio btn-group btn-group-yesno">
                            <input type="radio" name="image_published" id="image_published_1" value="0" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?>"  checked="checked"/>
                            <label for="image_published_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                            <input type="radio" name="image_published" id="image_published_2" value="1" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?>"/>
                            <label for="image_published_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        </fieldset>
                    </div>
                </div>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                    $pane3 = new CrBcPane();
                    echo $pane3->initPane(
                        array(
                            'translation-image-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                            'original-image-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                        )
                    );

                    echo $pane3->startPane();
                    echo $pane3->startPanel( 'translation-image-pane' );
                ?>
                    <div class="control-group">
                        <div class="control-label">
                            <label for="alt_name_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_ALT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IMAGE_ALT' ); ?></label>
                        </div>
                        <div class="controls">
                            <input type="text" name="alt_name_translation" id="alt_name_translation" value="" />
                        </div>
                    </div>

                    <div class="control-group">
                        <div class="control-label">
                            <label for="image_description_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_DESCRIPTION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                        </div>
                        <div class="controls">
                            <?php
                            JImport( 'joomla.html.editor' );
                            $editor = JFactory::getEditor();
                            echo $editor->display("image_description_translation",'', '100%', '350', '75', '20');
                            ?>
                        </div>
                    </div>
                <?php
                    echo $pane3->endPanel();
                    echo $pane3->startPanel( 'original-image-pane' );
                }
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="alt_name" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_ALT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IMAGE_ALT' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="alt_name" id="alt_name" value="" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="image_description" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_DESCRIPTION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                            JImport( 'joomla.html.editor' );
                            $editor = JFactory::getEditor();
                            echo $editor->display("image_description",'', '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                    echo $pane3->endPanel();
                    echo $pane3->endPane();
                }
                ?>

                </fieldset>

            </div>
        </div>
    </div>

    <?php
    echo $pane->endPanel();
    echo $pane->startPanel( 'files-pane' );
    ?>

    <div class="row-fluid">
        <div class="span12">
            <div class="form-horizontal">

                <div class="control-group">
                    <div class="control-label">&nbsp;
                    </div>
                    <div class="controls">
                        <a href="index.php?option=com_breezingcommerce&amp;controller=files&amp;product_id=<?php echo $this->product->id; ?>" title="<?php echo JText::_('COM_BREEZINGCOMMERCE_EDIT_FILES');?>" class="modal" rel="{handler: 'iframe', size: {x: 1024, y: 500}}"><?php echo JText::_('COM_BREEZINGCOMMERCE_EDIT_FILES');?></a> (<?php echo $this->amount_files;?>)
                    </div>
                </div>

                <fieldset>
                    <legend><?php echo JText::_('COM_BREEZINGCOMMERCE_NEW');?></legend>

                <div class="control-group">
                    <div class="control-label">
                        <label for="product_file" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_CHOOSE_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_FILE' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="file" name="product_file" id="product_file" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="file_name" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_FILE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="file_name" id="file_name" value="" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_REQUIRES_VERIFICATION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_REQUIRES_VERIFICATION' ); ?></label>
                    </div>
                    <div class="controls">

                        <fieldset id="file_verification_fieldset" class="radio btn-group btn-group-yesno">
                            <input type="radio" name="file_verification" id="file_verification_1" value="0" checked="checked" />
                            <label for="file_verification_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                            <input type="radio" name="file_verification" id="file_verification_2" value="1" />
                            <label for="file_verification_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        </fieldset>

                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="file_verification_days" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_VERIFICATION_DAYS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_VERIFICATION_DAYS' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="file_verification_days" id="file_verification_days" value="0" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="file_verification_tries" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_VERIFICATION_DOWNLOAD_TRIES_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_VERIFICATION_DOWNLOAD_TRIES' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="file_verification_tries" id="file_verification_tries" value="0" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PUBLISHED' ); ?></label>
                    </div>
                    <div class="controls">

                        <fieldset id="file_published_fieldset" class="radio btn-group btn-group-yesno">
                            <input type="radio" name="file_published" id="file_published_1" value="0" checked="checked" />
                            <label for="file_published_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                            <input type="radio" name="file_published" id="file_published_2" value="1" />
                            <label for="file_published_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        </fieldset>

                    </div>
                </div>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                    $pane4 = new CrBcPane();
                    echo $pane4->initPane(
                        array(
                            'translation-file-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                            'original-file-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                        )
                    );

                    echo $pane4->startPane();
                    echo $pane4->startPanel( 'translation-file-pane' );
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="file_description_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DESCRIPTION_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                            JImport( 'joomla.html.editor' );
                            $editor = JFactory::getEditor();
                            echo $editor->display("file_description_translation",'', '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                    echo $pane4->endPanel();
                    echo $pane4->startPanel( 'original-file-pane' );
                }
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="file_description" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DESCRIPTION_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                            JImport( 'joomla.html.editor' );
                            $editor = JFactory::getEditor();
                            echo $editor->display("file_description",'', '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                    echo $pane4->endPanel();
                    echo $pane4->endPane();
                }
                ?>

                </fieldset>

            </div>
        </div>
    </div>

    <?php
    echo $pane->endPanel();
    $use_weights = 1;
    if(true){
        $use_weights = 0;
        echo $pane->startPanel( 'weight-pane' );
    ?>

    <div class="row-fluid">
        <div class="span9">
            <div class="form-horizontal">

                <div class="control-group">
                    <div class="control-label">
                        <label for="weight" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WEIGHT_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_WEIGHT');?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="weight" id="weight" value="<?php echo $this->product->weight?>"/>
                        <select name="weight_type" class="chzn-done">
                            <option value="0"<?php echo $this->product->weight_type == 0 ? ' selected="selected"' : ''?>><?php echo $this->product->weight_type_big; ?></option>
                            <option value="1"<?php echo $this->product->weight_type == 1 ? ' selected="selected"' : ''?>><?php echo $this->product->weight_type_small; ?></option>
                            <option value="2"<?php echo $this->product->weight_type == 2 ? ' selected="selected"' : ''?>><?php echo $this->product->weight_type_micro; ?></option>
                        </select>
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="width" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DIMENSIONS_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_DIMENSIONS');?></label>
                    </div>
                    <div class="controls">

                            <div class="control-group">
                                <div class="control-label">
                                    <label for="width" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WIDTH_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_WIDTH')?> </label>
                                </div>
                                <div class="controls">
                                    <input type="text" name="width" id="width" value="<?php echo $this->product->width?>"/>
                                </div>
                            </div>

                            <div class="control-group">
                                <div class="control-label">
                                    <label for="height" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_HEIGHT_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_HEIGHT')?></label>
                                </div>
                                <div class="controls">
                                    <input type="text" name="height" id="height" value="<?php echo $this->product->height?>"/>
                                </div>
                            </div>

                            <div class="control-group">
                                <div class="control-label">
                                    <label for="length" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_LENGTH_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_LENGTH')?></label>
                                </div>
                                <div class="controls">
                                    <input type="text" name="length" id="length" value="<?php echo $this->product->length?>"/>
                                    <select name="dimension_type" class="chzn-done">
                                        <option value="0"<?php echo $this->product->dimension_type == 0 ? ' selected="selected"' : ''?>><?php echo $this->product->dimension_type_big; ?></option>
                                        <?php if( CrBcHelpers::getBcConfig()->get('dimension_type',0) != 1 ): ?>
                                        <option value="3"<?php echo $this->product->dimension_type == 3 ? ' selected="selected"' : ''?>><?php echo $this->product->dimension_type_medium; ?></option>
                                        <?php endif; ?>
                                        <option value="1"<?php echo $this->product->dimension_type == 1 ? ' selected="selected"' : ''?>><?php echo $this->product->dimension_type_small; ?></option>
                                        <?php if( CrBcHelpers::getBcConfig()->get('dimension_type',0) != 1 ): ?>
                                        <option value="2"<?php echo $this->product->dimension_type == 2 ? ' selected="selected"' : ''?>><?php echo $this->product->dimension_type_micro; ?></option>
                                        <?php endif; ?>
                                    </select>
                                </div>
                            </div>

                    </div>
                </div>

            </div>
        </div>
    </div>

    <?php
        echo $pane->endPanel();
    }
    echo $pane->startPanel( 'properties-pane' );
    ?>

    <div class="row-fluid">
        <div class="span6">
            <div class="form-horizontal well">

                <div class="control-group">
                    <div class="control-label">
                        <label for="property_sets" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTY_SELECTION_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_SELECT_PROPERTY_SET');?></label>
                    </div>
                    <div class="controls">
                        <?php require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );?>
                        <?php 
                        $options = CrBcProperties::getPropertyOptions($this->product->id, $this->product->property_id, $this->product->use_combinations); 
                        if(trim($options) == ''){
                            echo '-';
                        }else{
                            echo $options;
                        }
                        ?>
                    </div>
                </div>

            </div>
            
            <div class="form-horizontal well">

                <div class="control-group">
                    <div class="control-label">
                        <label for="property_readonly_sets" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTY_READONLY_SELECTION_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_SELECT_PROPERTY_READONLY_SET');?></label>
                    </div>
                    <div class="controls">
                        <?php require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );?>
                        <?php 
                        $options_readonly = CrBcProperties::getPropertyOptions($this->product->id, $this->product->property_readonly_id, 0, true);
                        if(trim($options_readonly) == ''){
                            echo '-';
                        }else{
                            echo $options_readonly;
                        }
                        ?>
                    </div>
                </div>

            </div>
            
        </div>
        
        <div class="span6 well">
            
            <div class="form-horizontal">

                <div class="control-group">
                    <div class="control-label">
                        <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_ATTRIBUTES_SELECTION_TIP' ); ?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_ATTRIBUTES_SELECTION');?></label>
                    </div>
                    <div class="controls">

                        <i id="product_attribute_names"></i>
                        <input type="hidden" name="product_attribute_ids" id="product_attribute_ids" value="" />
                        <i><a href="javascript:document.getElementById('product_attribute_names').innerHTML='';document.getElementById('product_attribute_ids').value='';void(0);"><?php echo JText::_('COM_BREEZINGCOMMERCE_CLEAR') ;?></a></i>
                        <br/>
                        <br/>
                        <a href="index.php?option=com_breezingcommerce&amp;controller=attributes&amp;tmpl=component&amp;layout=select_attribute&amp;backIds=product_attribute_ids&amp;backNames=product_attribute_names" title="<?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_ATTRIBUTES_SELECTION');?>" class="modal" rel="{handler: 'iframe', size: {x: 1024, y: 500}}"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT_ATTRIBUTES_SELECTION');?></a>
                        <?php
                        if($this->hasAttributes){
                            echo '<br/><br/><a href="index.php?option=com_breezingcommerce&amp;controller=productattributes&amp;product_id='.$this->product->id.'" title="" class="modal" rel="{handler: \'iframe\', size: {x: 1024, y: 500}}">'.JText::_('COM_BREEZINGCOMMERCE_PRODUCT_ATTRIBUTES_EDIT').'</a>'."\n";;
                        }
                        ?>

                    </div>
                </div>

            </div>
        </div>
    </div>
    
    <?php
    echo $pane->endPanel();
    echo $pane->startPanel( 'manufacturers-pane' );
    require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcManufacturersHelper.php' );
    ?>

    <div class="row-fluid">
       <div class="span9">
            <div class="form-horizontal">

                <div class="control-group">
                    <div class="control-label">
                        <label for="manufacturers" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_MANUFACTURERS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_MANUFACTURERS' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php JHtml::_('formbehavior.chosen', '#manufacturers'); ?>
                        <?php echo CrBcManufacturersHelper::getManufacturersMultipleSelectList(CrBcManufacturersHelper::getSelectedManufacturers($this->product->id), 'manufacturers[]', 10, '', 'width: 100%');?>
                    </div>
                </div>

            </div>
        </div>
    </div>

    <?php
    echo $pane->endPanel();
    echo $pane->startPanel( 'cart-pane' );
    ?>

    <div class="row-fluid">
        <div class="span12">

            <?php
            
            require_once(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php');

            // remember the selected currency
            $config = CrBcHelpers::getBcConfig();
            if( $config->get('allow_currency_selection', 0) && JRequest::getInt('crbc_set_currency', 0) != 0 ){
                JFactory::getDbo()->setQuery("Select id From #__breezingcommerce_currencies Where id = " . JRequest::getInt('crbc_set_currency', 0) . " And published = 1");
                if( JFactory::getDbo()->loadResult() ){
                    JFactory::getSession()->set('com_breezingcommerce.currency', JRequest::getInt('crbc_set_currency', 0));
                }
            }else if($config->get('allow_currency_selection', 0) != 1){
                JFactory::getSession()->clear('com_breezingcommerce.currency');
            }

            $db = JFactory::getDbo();
            $db->setQuery("Select * From #__breezingcommerce_currencies Where published = 1 Order By ordering");
            $currencies = $db->loadObjectList();

            JFactory::getDocument()->addStyleDeclaration('

                .crbc-mod_breezingcommerce_currencies{
                    width: 100%;
                    height: auto;
                    margin-bottom: 20px;
                }
            ');

            $url = JURI::getInstance()->toString();
            $url = preg_replace("/(.*)[&|?]crbc_set_currency=[0-9]*$/i",'${1}',$url);

            echo '<div class="crbc-mod_breezingcommerce_currencies">'."\n";

            foreach($currencies As $currency){

                $translated_object = CrBcHelpers::loadTranslation($currency->id, 'currency');
                if($translated_object !== null){
                    $currency->name = $translated_object->title;
                }

            ?>

            <a style="margin-bottom: 5px;" class="btn btn-secondary" href="<?php echo $url.(strstr($url,'?') !== false ? '&' : '?').'crbc_set_currency='.$currency->id; ?>"<?php echo JFactory::getSession()->get('com_breezingcommerce.currency', 0) == $currency->id ? ' disabled="disabled"' : ''?>>
                <?php echo $currency->symbol . ' ('.$currency->code.')'; ?>
            </a>

            <?php
            }

            echo '</div>'."\n";
            echo '<div style="clear:both"></div>'."\n";
            
            ?>

            <i id="cart_customer_name_display"><?php $cart = JFactory::getSession()->get('crbc_cart', array('customer_name'=>'','customer_id'=>0)); echo isset($cart['customer_name']) && $cart['customer_name'] ? htmlentities($cart['customer_name'], ENT_QUOTES, 'UTF-8') . '<br/>' : ''; ?></i>
            <input type="hidden" name="cart_customer_id" id="cart_customer_id" value="<?php echo $cart['customer_id'];?>"/>
            <input type="hidden" name="cart_customer_name" id="cart_customer_name" value="<?php echo htmlentities($cart['customer_name'], ENT_QUOTES, 'UTF-8');?>"/>
            <a href="index.php?option=com_breezingcommerce&amp;controller=customers&amp;tmpl=component&amp;layout=select_customer&amp;backId=cart_customer_id&amp;backName=cart_customer_name_display&amp;backHiddenName=cart_customer_name" title="<?php echo JText::_('COM_BREEZINGCOMMERCE_SELECT_CUSTOMER');?>" class="modal" rel="{handler: 'iframe', size: {x: 1024, y: 500}}"><?php echo JText::_('COM_BREEZINGCOMMERCE_SELECT_CUSTOMER');?></a>

            <br/>
            <br/>

            <?php
             require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcCart.php');
             $off = 0;
             $tax_lists = array();
             $total_net = 0;
             $total_gross = 0;
             $cart = new CrBcCart( JFactory::getSession()->get('crbc_cart', array()) );
             $cart_items = $cart->getItems();
             if(count($cart_items)){
             ?>
                <table class="table table-striped">
                 <tr>
                    <th align="left"><?php echo JText::_('COM_BREEZINGCOMMERCE_PRODUCT');?></th>
                    <th align="left">&nbsp;</th>
                    <th align="right"><?php echo JText::_('COM_BREEZINGCOMMERCE_AMOUNT');?></th>
                    <th align="right"><?php echo JText::_('COM_BREEZINGCOMMERCE_NET');?></th>
                    <th align="right"><?php echo JText::_('COM_BREEZINGCOMMERCE_TAXES');?></th>
                    <th align="right"><?php echo JText::_('COM_BREEZINGCOMMERCE_GROSS');?></th>
                </tr>
             <?php
             foreach($cart_items As $item){
                $total_net += $item->price_net <= 0 ? 0 : $item->price_net;
                $total_gross += $item->price_gross <= 0 ? 0 : $item->price_gross;
                $off += $item->off <= 0 ? 0 : $item->off;
                $tax_lists[] = $item->price_tax_list;
             ?>
                 <tr>
                    <td align="left" valign="top"><a href="index.php?option=com_breezingcommerce&amp;controller=products&amp;task=edit&amp;cid[]=<?php echo $item->id;?>&amp;limitstart=<?php echo JRequest::getInt('limitstart', 0);?>"><?php echo $item->title;?> (<?php echo $item->id;?>)</a></td>
                    <td align="left" valign="top">&nbsp;</td>
                    <td align="right" valign="top"><?php echo $item->amount;?></td>
                    <td align="right" valign="top"><?php echo $cart->formatPrice($item->price_net <= 0 ? 0 : $item->price_net);?></td>
                    <td align="right" valign="top"><?php
                    $taxes = 0;
                    foreach($item->price_tax_list As $id => $info){
                        $taxes += $info['tax'] <= 0 ? 0 : $info['tax'];
                    }
                    ?><?php echo $cart->formatPrice($taxes);?></td>
                    <td align="right" valign="top"><?php echo $cart->formatPrice($item->price_gross <= 0 ? 0 : $item->price_gross);?></td>
                 </tr>
             <?php
             }
             ?>
                <tr>
                    <td align="right" valign="top" colspan="6" style="background-color: lightgrey;">&nbsp;</td>
                </tr>
                <tr>
                    <td align="left" valign="top">&nbsp;</td>
                    <td align="left" valign="top">&nbsp;</td>
                    <td align="left" valign="top">&nbsp;</td>
                    <td align="left" valign="top">&nbsp;</td>
                    <td align="right" valign="top"><?php echo JText::_('COM_BREEZINGCOMMERCE_TOTAL');?>:</td>
                    <td align="right" valign="top"><?php echo $cart->formatPrice($total_gross);?></td>
                </tr>
                <tr>
                    <th align="right" valign="top" colspan="6"><i><?php echo JText::_('COM_BREEZINGCOMMERCE_COSTS_DISCOUNTS');?>:</i></th>
                </tr>
                <?php
                $taxes = array();
                foreach($tax_lists As $tax_list){
                     foreach($tax_list As $id => $info){
                         if(!isset($taxes[$id])){
                             $taxes[$id] = array('name'=>$info['name'],'tax'=>0,'rate'=>$info['rate']);
                         }
                         $taxes[$id]['tax'] += $info['tax'] <= 0 ? 0 : $info['tax'];
                     }
                 }

                 foreach($taxes As $tax){
                 ?>
                    <tr>
                        <td align="right" valign="top" colspan="5"><i><?php echo $tax['name'];?> (<?php echo CrBcCart::formatNumber($tax['rate']);?> %):</i></td>
                        <td align="right" valign="top"><i><?php echo $cart->formatPrice($tax['tax']);?></i></td>
                    </tr>
                 <?php
                 }

                 if($off > 0){
                 ?>
                    <tr>
                        <td align="right" valign="top" colspan="5"><i><?php echo JText::_('COM_BREEZINGCOMMERCE_DISCOUNT')?>:</i></td>
                        <td align="right" valign="top"><i>-<?php echo $cart->formatPrice($off);?></i></td>
                    </tr>
                <?php
                }
                ?>
             </table>
            <?php
            }
            ?>

            <div class="span5">

                <?php
                $amount = 0;
                $cart2 = JFactory::getSession()->get('crbc_cart', array('products'=>array()));
                $size = count(isset($cart2['products']) ? $cart2['products'] : array());
                for ($i = 0; $i < $size; $i++) {
                    if ($this->product->id == $cart2['products'][$i]['id']) {
                        $amount = $cart2['products'][$i]['amount'];
                        break;
                    }
                }

                echo CrBcProperties::getPropertySelectors($this->product->id, $amount, $cart->getSelectedPropertyValueIds(),$this->product->use_combinations);
                ?>

            </div>

            <div class="span5">
                <?php
                require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );
                require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcAttributes.php' );
                JFactory::getDocument()->addScriptDeclaration(CrBcProperties::getPropertyJs());
                JFactory::getDocument()->addScriptDeclaration(CrBcAttributes::getAttributeJs());
                JFactory::getDocument()->addScriptDeclaration(CrBcAttributes::getRequiredJs());
                require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcAttributes.php' );
                echo CrBcAttributes::getAttributesForm($this->product->id, $amount, $cart->getSelectedAttributeItemIds());
                ?>
            </div>

            <div class="ct-clear"></div>

            <br/>

            <input type="text" size="2" name="cart_add_amount" value="<?php echo $amount > 0 ? $amount : 1;?>" id="cart_add_amount"/>
            <input type="hidden" name="cart_add" value="0" id="cart_add"/>
            <br />
            <a href="javascript:if(typeof crbcTriggerCartValidations != 'undefined'){crbcTriggerCartValidations = true;}document.getElementById('cart_add').value='<?php echo $this->product->id;?>';submitbutton('apply');void(0);"><?php echo JText::_('COM_BREEZINGCOMMERCE_UPDATE_CART');?></a>
            -
            <a href="javascript:var result = confirm('<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_CART_CLEAR_MSG'))?>');if(result){document.getElementById('cart_add').value='clear';submitbutton('apply');}void(0);"><?php echo JText::_('COM_BREEZINGCOMMERCE_CLEAR_CART');?></a>
            <?php
            if($size > 0){
            ?>
            -
            <a href="javascript:var result = confirm('<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_CART_PROCEED'))?>'); if(result){location.href='index.php?option=com_breezingcommerce&amp;controller=orders&amp;cid[]=<?php echo $cart2['order_id'];?>&amp;task=edit&amp;clear_cart=true';}void(0);"><?php echo JText::_('COM_BREEZINGCOMMERCE_CART_ORDER_OVERVIEW');?></a>
            <?php
            }
            ?>

        </div>
    </div>

    <?php
    $leaf = 0;
    if(count($this->product->price_plugins)){
        $leaf++;
        echo $pane->endPanel();
        echo $pane->startPanel( 'priceplugins-pane' );
        ?>

        <table width="100%" class="paramlist admintable" cellspacing="1">
        <?php
        foreach($this->product->price_plugins As $plugin){
            $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type);
            $instance = new $class();
            $viewport = $instance->productViewport($this->product->id, 0);
            if($viewport){
        ?>
            <tr>
                <td width="40%" class="paramlist_key" valign="top"><?php echo $instance->getPluginDisplayName();?></td>
                <td class="paramlist_value"><div><?php echo $viewport; ?></div></td>
            </tr>
        <?php
            }
        }
        ?>
        </table>
    <?php } ?>

    <?php
    if(count($this->product->display_plugins)){
        $leaf++;
        echo $pane->endPanel();
        echo $pane->startPanel( 'displayplugins-pane' );
        ?>
        <table width="100%" class="paramlist admintable" cellspacing="1">
        <?php
        $plugin = array();
        foreach($this->product->display_plugins As $plugin){
            $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type);
            $instance = new $class();
            $viewport = $instance->productViewport($this->product->id, 0);
            if($viewport){
        ?>
            <tr>
                <td width="40%" class="paramlist_key" valign="top"><?php echo $instance->getPluginDisplayName();?></td>
                <td class="paramlist_value"><div><?php echo $viewport; ?></div></td>
            </tr>
        <?php
            }
        }
        ?>
        </table>
    <?php } ?>

    <?php
    echo $pane->endPanel();
    echo $pane->startPanel( 'parametersadvanced-pane' );
    ?>
    
    <div class="row-fluid">
        <div class="span6">
                <div class="form-horizontal">
                    <?php echo CrBcForm::render(
                        array(
                            'backorders',
                            'minimum_amount',
                            'maximum_amount',
                            'immediate_checkout',
                            'immediate_checkout_singleton',
                            'verification_days',
                            'verification_groups',
                            'hide_price',
                        ),
                        $this->product->attribs,
                        'product',
                        'params'
                    ); ?>
                </div>
        </div>
    
    
        <div class="span6">
            <div class="form-horizontal">

                <?php
                // translations
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                    $pane3 = new CrBcPane();
                    echo $pane3->initPane(
                        array(
                            'translation1-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                            'original1-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                        )
                    );

                    echo $pane3->startPane();
                    echo $pane3->startPanel( 'translation1-pane' );
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="metakey_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_METAKEY_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_METAKEY' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="metakey_translation" value="<?php echo htmlentities( $this->product->metakey_translation, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="metadesc_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_METADESC_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_METADESC' ); ?></label>
                    </div>
                    <div class="controls">
                        <textarea name="metadesc_translation"><?php echo htmlentities( $this->product->metadesc_translation, ENT_QUOTES, 'UTF-8');?></textarea>
                    </div>
                </div>

                <?php echo CrBcForm::render(
                    array(
                        'robots',
                        'author',
                        'rights',
                        'xreference'
                    ),
                    $this->product->metadata_translation,
                    'metadata',
                    'metadata',
                    'params_translation'
                );?>

                <?php
                    echo $pane3->endPanel();
                    echo $pane3->startPanel( 'original1-pane' );
                }

                // default (all) case
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="metakey" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_METAKEY_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_METAKEY' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="metakey" value="<?php echo htmlentities( $this->product->metakey, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="metadesc" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_METADESC_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_METADESC' ); ?></label>
                    </div>
                    <div class="controls">
                        <textarea name="metadesc"><?php echo htmlentities( $this->product->metadesc, ENT_QUOTES, 'UTF-8');?></textarea>
                    </div>
                </div>

                <?php echo CrBcForm::render(
                    array(
                        'robots',
                        'author',
                        'rights',
                        'xreference'
                    ),
                    $this->product->metadata,
                    'metadata',
                    'metadata',
                    'params'
                );?>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                    echo $pane3->endPanel();
                    echo $pane3->endPane();
                }
                // translations end
                ?>

            </div>
        </div>
        
    </div>
    
    <?php

    echo $pane->endPanel();
    echo $pane->endPane();
    ?>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->product->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->product->id; ?>" />
<input type="hidden" name="task" id="task" value="" />
<input type="hidden" name="boxchecked" value="1" /><!-- Faked, because customX and custom toolbar expects it -->
<input type="hidden" name="controller" value="products" />
<input type="hidden" name="created" value="<?php echo $this->product->created ;?>" />
<input type="hidden" name="created_by" value="<?php echo $this->product->created_by ;?>" />
<input type="hidden" name="created_by_alias" value="<?php echo $this->product->created_by_alias ;?>" />
<input type="hidden" name="modified" value="<?php echo $this->product->modified ;?>" />
<input type="hidden" name="modified_by" value="<?php echo $this->product->modified_by ;?>" />
<input type="hidden" name="modified_by_alias" value="<?php echo $this->product->modified_by_alias ;?>" />
<input type="hidden" name="limitstart" value="<?php echo $this->limitstart ;?>" />
<input type="hidden" name="tabStartOffset" value="<?php echo $this->tabStartOffset; ?>" />

</form>

<script type="text/javascript">
<?php
foreach($pane->tabs As $tab => $title){
?>
    jQuery('#<?php echo $tab;?>_tab').click(
        function(){
            document.adminForm.tabStartOffset.value = <?php echo json_encode('product.tab.'.$this->product->id.'.'.$tab);?>;
        }
    );
    if(document.adminForm.tabStartOffset.value != ''){
        jQuery('#<?php echo $tab;?>_tab').parent().removeClass('active');
        jQuery('#<?php echo $tab;?>').removeClass('active');
    }

<?php
}
?>

    jQuery('#<?php echo str_replace('product.tab.'.$this->product->id.'.','',$this->tabStartOffset);?>_tab').parent().addClass('active');
    jQuery('#<?php echo str_replace('product.tab.'.$this->product->id.'.','',$this->tabStartOffset);?>').addClass('active');
</script>
