<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
            case 'apply':
                var error = false;

                if(!error)
                {
                    submitform(pressbutton);
                }

                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>


<a href="#" onclick="javascript: submitbutton('save')" class="toolbar btn">
<span class="icon-save" title="Save">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_SAVE'); ?>
</a>

<a href="#" onclick="javascript: submitbutton('apply')" class="toolbar btn">
<span class="icon-apply" title="Apply">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_APPLY'); ?>
</a>

<a href="#" onclick="javascript: submitbutton('cancel')" class="toolbar btn">
<span class="icon-cancel" title="Close">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_CLOSE'); ?>
</a>

<br/>
<br/>

<form action="index.php" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">

        <div class="form-horizontal">

            <div class="control-group">
                <div class="control-label">
                    <label for="name" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_VARIATION_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="name" id="name" maxlength="250" value="<?php echo htmlentities( $this->combination->name, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="price" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_VARIATION_PRICE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRICE' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="price" id="price" maxlength="250" value="<?php echo htmlentities( $this->combination->price < 0 ? '' : $this->combination->price, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_VARIATION_SELECTED_TIP' ); ?>">
                    <?php echo JText::_( 'COM_BREEZINGCOMMERCE_SELECTED' ); ?>
                    </label>
                </div>
                <div class="controls">
                    <fieldset id="selected_fieldset" class="radio btn-group btn-group-yesno">
                        <input type="radio" id="selected_1" name="selected" value="1"<?php echo $this->combination->selected ? ' checked="checked"' : ''?>/>
                        <label for="selected_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        <input type="radio" id="selected_2" name="selected" value="0"<?php echo !$this->combination->selected ? ' checked="checked"' : ''?>/>
                        <label for="selected_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                    </fieldset>
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_VARIATION_COMBINATION_TIP' ); ?>">
                    <?php echo JText::_( 'COM_BREEZINGCOMMERCE_COMBINATION' ); ?>
                    </label>
                </div>
                <div class="controls">
                    <?php
                    echo CrBcProperties::getPropertyCombinationOptions($this->product_id, $this->property_id, $this->combination->id);
                    ?>
                </div>
            </div>

            <?php
            if(!$this->combination->virtual_product){
            ?>

            <div class="control-group">
                <div class="control-label">
                    <label for="stock" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="stock" id="stock" maxlength="250" value="<?php echo $this->combination->stock;?>" />
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="weight" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WEIGHT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WEIGHT' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="weight" id="weight" value="<?php echo $this->combination->weight?>"/>
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="weight_type" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WEIGHT_TYPE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WEIGHT_TYPE' ); ?></label>
                </div>
                <div class="controls">
                    <select name="weight_type" id="weight_type" class="chzn-done">
                        <option value="0"<?php echo $this->combination->weight_type == 0 ? ' selected="selected"' : ''?>><?php echo $this->combination->weight_type_big; ?></option>
                        <option value="1"<?php echo $this->combination->weight_type == 1 ? ' selected="selected"' : ''?>><?php echo $this->combination->weight_type_small; ?></option>
                        <option value="2"<?php echo $this->combination->weight_type == 2 ? ' selected="selected"' : ''?>><?php echo $this->combination->weight_type_micro; ?></option>
                    </select>
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DIMENSIONS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DIMENSIONS' ); ?></label>
                </div>
                <div class="controls">


                        <div class="control-group">
                            <div class="control-label">
                                <label for="width" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WIDTH_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_WIDTH' ); ?></label>
                            </div>
                            <div class="controls">
                                <input type="text" name="width" id="width" value="<?php echo $this->combination->width?>"/>
                            </div>
                        </div>

                        <div class="control-group">
                            <div class="control-label">
                                <label for="height" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_HEIGHT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_HEIGHT' ); ?></label>
                            </div>
                            <div class="controls">
                                <input type="text" name="height" id="height" value="<?php echo $this->combination->height?>"/>
                            </div>
                        </div>

                        <div class="control-group">
                            <div class="control-label">
                                <label for="length" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_LENGTH_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_LENGTH' ); ?></label>
                            </div>
                            <div class="controls">
                                <input type="text" name="length" id="length" value="<?php echo $this->combination->length?>"/>
                            </div>
                        </div>

                        <div class="control-group">
                            <div class="control-label">
                                <label for="dimension_type" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DIMENSIONS_TYPE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_DIMENSIONS_TYPE' ); ?></label>
                            </div>
                            <div class="controls">
                                <select name="dimension_type" id="dimension_type" class="chzn-done">
                                    <option value="0"<?php echo $this->combination->dimension_type == 0 ? ' selected="selected"' : ''?>><?php echo $this->combination->dimension_type_big; ?></option>
                                    <?php if( CrBcHelpers::getBcConfig()->get('dimension_type',0) != 1 ): ?>
                                    <option value="3"<?php echo $this->combination->dimension_type == 3 ? ' selected="selected"' : ''?>><?php echo $this->combination->dimension_type_medium; ?></option>
                                    <?php endif; ?>
                                    <option value="1"<?php echo $this->combination->dimension_type == 1 ? ' selected="selected"' : ''?>><?php echo $this->combination->dimension_type_small; ?></option>
                                    <?php if( CrBcHelpers::getBcConfig()->get('dimension_type',0) != 1 ): ?>
                                    <option value="2"<?php echo $this->combination->dimension_type == 2 ? ' selected="selected"' : ''?>><?php echo $this->combination->dimension_type_micro; ?></option>
                                    <?php endif; ?>
                                </select>
                            </div>
                        </div>


                </div>
            </div>

            <?php
            }else{
            ?>

            <div class="control-group">
                <div class="control-label">
                    <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_STOCK' ); ?></label>
                </div>
                <div class="controls">
                    <i><?php echo JText::_('COM_BREEZINGCOMMERCE_VIRTUAL_PRODUCT');?></i>
                    <input type="hidden" name="stock" id="stock" value="<?php echo $this->combination->stock;?>" />
                </div>
            </div>

            <?php
            }
            ?>

            <h3><?php echo JText::_('COM_BREEZINGCOMMERCE_PRICE_PLUGINS'); ?></h3>

            <?php
            foreach ($this->combination->price_plugins As $plugin) {
                $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type);
                $instance = new $class();
                $viewport = $instance->productViewport($this->product_id, $this->combination->id);
                if ($viewport) {
            ?>
            <div class="form-vertical">
                <div class="control-group">
                    <div class="control-label">
                        <label>
                        <?php echo $instance->getPluginDisplayName();?>
                        </label>
                    </div>
                    <div class="controls">
                        <?php echo $viewport; ?>
                    </div>
                </div>
            </div>
            <?php
                }
            }
            ?>

            <h3><?php echo JText::_('COM_BREEZINGCOMMERCE_DISPLAY_PLUGINS'); ?></h3>

            <?php
            $plugin = array();
            foreach ($this->combination->display_plugins As $plugin) {
                $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type);
                $instance = new $class();
                $viewport = $instance->productViewport($this->product_id, $this->combination->id);
                if ($viewport) {
            ?>
            <div class="form-vertical">
                <div class="control-group">
                    <div class="control-label">
                        <label>
                            <?php echo $instance->getPluginDisplayName();?>
                        </label>
                    </div>
                    <div class="controls">
                        <?php echo $viewport; ?>
                    </div>
                </div>
            </div>
            <?php
                            }
                    }
            ?>



        </div>


<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->combination->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->combination->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="productpropertycombinations" />
<input type="hidden" name="ordering" value="<?php echo $this->combination->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->combination->published ;?>" />
<input type="hidden" name="required" value="<?php echo $this->combination->required ;?>" />
<input type="hidden" name="product_id" value="<?php echo $this->product_id ;?>" />
<input type="hidden" name="property_id" value="<?php echo $this->property_id ;?>" />
<input type="hidden" name="limitstart" value="<?php echo $this->limitstart ;?>" />
</form>
