<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if(document.getElementById("name").value == ""){
                    error = true;
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_TAXRATE_NAME'));?>");
                }
                else if(document.adminForm.country_id.selectedIndex == -1 || document.adminForm.country_id.options[document.adminForm.country_id.selectedIndex].value == ""){
                    error = true;
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_TAXRATE_COUNTRY'));?>");
                } else if(isNaN(document.getElementById("rate_percent").value)){
                    error = true;
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_TAXRATE'));?>");
                }

                if(!error)
                {
                    submitform(pressbutton);
                }
                
                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>
<form action="index.php" method="post" name="adminForm" id="adminForm">
    
    <div class="form-horizontal">
        
        <?php
        // translations
        if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

            $pane2 = new CrBcPane();
            echo $pane2->initPane(
                array(
                    'translation-name-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                    'original-name-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                )
            );

            echo $pane2->startPane();
            echo $pane2->startPanel( 'translation-name-pane' );
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="name_translation" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name_translation" id="name_translation" maxlength="250" value="<?php echo htmlentities( $this->taxrate->name_translation, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <?php
                            echo $pane2->endPanel();
            echo $pane2->startPanel( 'original-name-pane' );
        }
        // default (all) case
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name" id="name" maxlength="250" value="<?php echo htmlentities( $this->taxrate->name, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <?php
        if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
            echo $pane2->endPanel();
            echo $pane2->endPane();
        }
        // translations end
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="country_id" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_COUNTRY_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_COUNTRY' ); ?></label>
            </div>
            <div class="controls">
                <select class="chzn-done" name="country_id" id="country_id" onchange="crbcSwitchCountry()">
                    <option value=""><?php echo JText::_('COM_BREEZINGCOMMERCE_SELECT_ONE');?></option>
                    <option value="0"<?php echo $this->taxrate->country_id == 0 ? ' selected="selected"': '' ?>><?php echo JText::_('COM_BREEZINGCOMMERCE_NONE');?></option>
                    <?php
                    foreach($this->taxrate->countries As $country){
                    ?>
                    <option value="<?php echo $country->id;?>"<?php echo $country->id == $this->taxrate->country_id ? ' selected="selected"': '' ?>><?php echo htmlentities( $country->name, ENT_QUOTES, 'UTF-8');?></option>
                    <?php
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="region_id" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_REGION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_REGION' ); ?></label>
            </div>
            <div class="controls">
            
                <select class="chzn-done" name="region_id" id="region_id">
                    <option value="0">*</option>
                </select>
                <script type="text/javascript">
                <!--
                countries = new Array();
                <?php
                foreach($this->taxrate->countries As $country){
                    $regions = '';
                    $size = count($country->regions);
                    $i = 0;
                    foreach($country->regions As $region){
                        $regions .= '{';
                        $regions .= 'name: "'.addslashes($region->name).'", code: "'.addslashes($region->code).'", id: '.$region->id.'';
                        $regions .= '}';
                        if($i + 1 < $size){
                            $regions .= ',';
                        }
                        $i++;
                    }

                    echo 'countries.push({country_id : "'.addslashes($country->id).'", regions: ['.$regions.']});'."\n";
                }
                ?>
                var countrySelected = document.adminForm.country_id.selectedIndex != -1 ? document.adminForm.country_id.options[document.adminForm.country_id.selectedIndex].value : 0;
                var regionSelected  = <?php echo $this->taxrate->region_id ? $this->taxrate->region_id: 0?>;
                crbcSwitchRegion(countrySelected, regionSelected);
                //-->
                </script>
                
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_IS_RANGE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IS_RANGE' ); ?></label>
            </div>
            <div class="controls">
                <input onclick="document.getElementById('row_is_range').style.display='';document.getElementById('row_is_not_range').style.display='none';" type="radio" name="is_range" id="is_range" value="1"<?php echo $this->taxrate->is_range ? ' checked="checked"' : ''?>/>
                <?php echo JText::_('COM_BREEZINGCOMMERCE_YES') ;?>
                <input onclick="document.getElementById('row_is_range').style.display='none';document.getElementById('row_is_not_range').style.display='';" type="radio" name="is_range" id="is_range" value="0"<?php echo $this->taxrate->is_range ? '' : ' checked="checked"'?>/>
                <?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?>
            </div>
        </div>
        
        <div class="control-group" id="row_is_not_range" style="<?php echo $this->taxrate->is_range ? 'display:none' : '';?>">
            <div class="control-label">
                <label for="zip_code" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_IF_IT_IS_NOT_RANGE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IF_IT_IS_NOT_RANGE' ); ?></label>
            </div>
            <div class="controls">
                    <input type="text" name="zip_code" id="zip_code" maxlength="250" value="<?php echo htmlentities( $this->taxrate->zip_code, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <div class="control-group" id="row_is_range" style="<?php echo $this->taxrate->is_range ? '' : 'display:none';?>">
            <div class="control-label">
                <label for="range_from"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IF_IS_RANGE' ); ?></label>
            </div>
            <div class="controls">
                <?php echo JText::_('COM_BREEZINGCOMMERCE_RANGE_FROM');?>
                <br/>
                <input type="text" name="range_from" id="range_from" maxlength="250" value="<?php echo htmlentities( $this->taxrate->range_from, ENT_QUOTES, 'UTF-8');?>" />
                <br/>
                <?php echo JText::_('COM_BREEZINGCOMMERCE_RANGE_TO');?>
                <br/>
                <input type="text" name="range_to" id="range_to" maxlength="250" value="<?php echo htmlentities( $this->taxrate->range_to, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="rate_percent" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAXRATE_RATE_PERCENT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_RATE_PERCENT' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="rate_percent" id="rate_percent" maxlength="250" value="<?php echo htmlentities( $this->taxrate->rate_percent, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
    </div>
    

<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->taxrate->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->taxrate->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="taxrates" />
<input type="hidden" name="default" value="<?php echo $this->taxrate->default ;?>" />
<input type="hidden" name="ordering" value="<?php echo $this->taxrate->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->taxrate->published ;?>" />
</form>


