var CrBcProduct = function(product_id){
    
    var _ajax_cart = false;
    var _current_url = '';
    var _url_parameters_init = '?';
    var _min_amount = 1;
    var _max_amount = 99999;
    this.product_id = product_id;
    this.isComplex = false;
    
    _self = this;
    
    switch(arguments.length){
        case 2: _ajax_cart = arguments[1]; break;
        case 3: 
            _ajax_cart = arguments[1]; 
            _current_url = arguments[2]; 
            
            if(_current_url.indexOf('?') !== -1){
                _url_parameters_init = '&';
            }
            
        break;
        case 4: 
            _ajax_cart = arguments[1]; 
            _current_url = arguments[2]; 
            
            if(_current_url.indexOf('?') !== -1){
                _url_parameters_init = '&';
            }
            
            _min_amount = arguments[3];
            
        break;
        case 5: 
            _ajax_cart = arguments[1]; 
            _current_url = arguments[2]; 
            
            if(_current_url.indexOf('?') !== -1){
                _url_parameters_init = '&';
            }
            
            _min_amount = arguments[3];
            _max_amount = arguments[4];
             
        break;
    }
    
    this.apply_display_plugins = function(){
        
        var the_select = arguments[0];
        
        jQuery.ajax(
        {
            url : 'index.php?option=com_breezingcommerce&controller=product&format=json&layout=json_apply_display_plugins&task=apply_display_plugins&is_complex='+(_self.isComplex ? 1 : 0),
            type: "POST",
            data: {
                'product_id' : product_id,
                'combination_id' : the_select ? jQuery(the_select).val() : 0
            },
            success: function(data, textStatus, jqXHR){
                
                //console.log(data);
                
                // TODO: apply on product id instead globally because of category views
                
                for(var i = 0; i < data.before_price.length; i++){
                    if( data.refreshable[i] ){
                        jQuery('#crbc-info-item-before-price-'+product_id+'-'+i).html(data.before_price[i]);
                    }
                }
                
                for(var i = 0; i < data.after_price.length; i++){
                    if( data.refreshable[i] ){
                        jQuery('#crbc-info-item-after-price-'+product_id+'-'+i).html(data.after_price[i]);
                    }
                }
                
                for(var i = 0; i < data.before_description.length; i++){
                    if( data.refreshable[i] ){
                        jQuery('#crbc-info-item-before-description-'+product_id+'-'+i).html(data.before_description[i]);
                    }
                }
                
                for(var i = 0; i < data.after_description.length; i++){
                    if( data.refreshable[i] ){
                        jQuery('#crbc-info-item-after-description-'+product_id+'-'+i).html(data.after_description[i]);
                    }
                }
                
                for(var i = 0; i < data.inside_footer.length; i++){
                    if( data.refreshable[i] ){
                        jQuery('#crbc-info-item-inside-footer-'+product_id+'-'+i).html(data.inside_footer[i]);
                    }
                }
                
                for(var i = 0; i < data.default.length; i++){
                    if( data.refreshable[i] ){
                        jQuery('#crbc-info-default-'+product_id+'-'+i).html(data.default[i]);
                    }
                }
                
                //console.log(data.after_price);
            },
            error: function(jqXHR, textStatus, errorThrown){
                console.log(errorThrown); 
            }
        });
    };
    
    this.update_qty = function(amount){
        
        var _min_amount = 1;
        var _max_amount = 99999;
        
        switch(arguments.length){
            case 2: _min_amount = arguments[1]; break;
            case 3: _max_amount = arguments[1]; _max_amount = arguments[2]; break;
        }
        
        var qty = parseInt(jQuery('#crbc-quantity-'+product_id).val());
        
        var result = isNaN(qty) ? _min_amount : amount + qty;
        if(result < _min_amount){
            result = _min_amount;
        }
        if(result > _max_amount){
            result = _max_amount;
        }
        jQuery('#crbc-quantity-'+product_id).val(result);
        this.update_price();
    }
    
    this.update_price = function(){
        
        if(!_ajax_cart){ return; }
        
        var product_attribute_item_ids = {};
        var product_property_ids = [];
        
        // collect selected product attribute item ids and their amounts
        
        jQuery('#crbc-attributes-'+product_id+' .crbcAttributes').each(function(){

            var element = jQuery(this).get(0);

            if(typeof element !== "undefined"){

                if(jQuery(element).hasClass('crbcAttributeRadio') || jQuery(element).hasClass('crbcAttributeCheckbox')){
                    if( element.checked ){
                        var closest_wrap = jQuery(element).closest('.crbcAttributeWrapper');
                        var attribute_id = jQuery(closest_wrap).attr('id').split('crbcAttributeWrapper')[1];
                        if(typeof product_attribute_item_ids['attribute_'+attribute_id] == "undefined" || !product_attribute_item_ids['attribute_'+attribute_id]){
                            product_attribute_item_ids['attribute_'+attribute_id] = {'amount': jQuery('#crbcAttributesAmounts'+attribute_id).size() > 0 ? parseInt(jQuery('#crbcAttributesAmounts'+attribute_id).val()) : 1 , 'product_attribute_item_ids': []};
                        }
                        product_attribute_item_ids['attribute_'+attribute_id]['product_attribute_item_ids'].push(element.value);
                    }
                } else {
                    
                    var closest_wrap = jQuery(element).closest('.crbcAttributeWrapper');
                    var attribute_id = jQuery(closest_wrap).attr('id').split('crbcAttributeWrapper')[1];
                    
                    if(typeof product_attribute_item_ids['attribute_'+attribute_id] == "undefined" || !product_attribute_item_ids['attribute_'+attribute_id]){
                        product_attribute_item_ids['attribute_'+attribute_id] = {'amount': jQuery('#crbcAttributesAmounts'+attribute_id).size() > 0 ? parseInt(jQuery('#crbcAttributesAmounts'+attribute_id).val()) : 1 , 'product_attribute_item_ids': []};
                    }
                    
                    var selected = jQuery(element).val();
                    if(jQuery.isArray(selected)){
                        
                        for(var i = 0; i < selected.length; i++){
                            product_attribute_item_ids['attribute_'+attribute_id]['product_attribute_item_ids'].push(selected[i]);
                        }
                        
                    } else {
                        
                        product_attribute_item_ids['attribute_'+attribute_id]['product_attribute_item_ids'].push(selected);
                    }
                }
            }
        });
        
        // collect selected properties
        
        jQuery('#crbc-properties-'+product_id+' .crbcProperties').each(function(){
            product_property_ids.push(parseInt(jQuery(this).val()));
        });
        
        var _the_amount = parseInt(jQuery('#crbc-quantity-'+product_id).val()) < 0 || parseInt(jQuery('#crbc-quantity-'+product_id).val()) < _min_amount || isNaN(parseInt(jQuery('#crbc-quantity-'+product_id).val())) ? _min_amount : parseInt(jQuery('#crbc-quantity-'+product_id).val()) > _max_amount ? _max_amount : parseInt(jQuery('#crbc-quantity-'+product_id).val() );
        jQuery('#crbc-quantity-'+product_id).val(_the_amount);
        
        if(jQuery('#crbc-total-price-spinner').size() != 0){
            jQuery('#crbc-total-price-0').css('display','none');
            jQuery('.crbc-total-price-group').css('display','none');
            jQuery('#crbc-total-price-spinner').css('display','block');
        }
        
        if(jQuery('#crbc-total-price-spinner-'+product_id).size() != 0){
            jQuery('#crbc-total-price-'+product_id+'-0').css('display','none');
            jQuery('#crbc-total-price-group-'+product_id).css('display','none');
            jQuery('#crbc-total-price-spinner-'+product_id).css('display','block');
        }
    
        jQuery.ajax(
        {
            url : 'index.php?option=com_breezingcommerce&controller=product&format=json&layout=json_get_product_price&task=get_product_price',
            type: "POST",
            data: {
                'product_attribute_item_ids' : product_attribute_item_ids,
                'product_property_ids' :  product_property_ids,
                'product_id' : product_id,
                'amount' : _the_amount
            },
            error: function(jqXHR, textStatus, errorThrown){
                console.log(errorThrown); 
                console.log(textStatus); 
                console.log(jqXHR); 
            },
            success: function(data, textStatus, jqXHR){
                
                jQuery('#crbc-total-price-spinner').css('display','none');
                jQuery('#crbc-total-price-spinner-'+product_id).css('display','none');
                jQuery('#crbc-total-price').css('display','block');
                jQuery('#crbc-total-price-'+product_id).css('display','block');
        
                jQuery('#crbc-total-price-0').html(data.price_group[0]);
                jQuery('#crbc-total-price-'+product_id+'-0').html(data.price_group[0]);
                
                jQuery('#crbc-total-price-0').css('display','block');
                jQuery('#crbc-total-price-'+product_id+'-0').css('display','block');
                
                // it's one-time use, only
                jQuery('#crbc-total-price-spinner-'+product_id).remove();
                jQuery('#crbc-total-price-spinner').remove();
                
                if(data.price_group.length >= 4){
                    
                    jQuery('.crbc-total-price-group').css('display','block');
                    jQuery('#crbc-total-price-1').html(data.price_group[1]);
                    jQuery('#crbc-total-price-2').html(data.price_group[2]);
                    jQuery('#crbc-total-price-3').html(data.price_group[3]);
                    
                    jQuery('#crbc-total-price-group-'+product_id).css('display','block');
                    jQuery('#crbc-total-price-'+product_id+'-1').html(data.price_group[1]);
                    jQuery('#crbc-total-price-'+product_id+'-2').html(data.price_group[2]);
                    jQuery('#crbc-total-price-'+product_id+'-3').html(data.price_group[3]);
                    
                    
                    //code to update the top price and sale price
                
                    //jQuery('#crbc-product-price').css('display','block');
                    //jQuery('#crbc-product-price-'+product_id).css('display','block');
                    //jQuery('#crbc-product-price-group-'+product_id).html(data.price_group[0]);
                    //jQuery('#crbc-product-price-'+product_id+'-1').html(data.price_group[1]);
                    //jQuery('#crbc-product-price-'+product_id+'-2').html(data.price_group[2]);
                    //jQuery('#crbc-product-price-'+product_id+'-3').html(data.price_group[3]);
                    
                    /** Not doing sale prices here
                    if(data.price_group[0] != data.sale_price_group[0]){
                        jQuery('#crbc-product-sale-price').html(data.sale_price_group[0]);
                        jQuery('#crbc-product-sale-price-container').css('display','block');
                    } else {
                        jQuery('#crbc-product-sale-price-container').css('display','none');
                    }*/
                    
                }
                
            },
            error: function(jqXHR, textStatus, errorThrown){
                console.log(jqXHR); 
            }
        });
    }; 
}

